/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 ***************************************************************************/

/***************************************************************************
*   ROM 2.4 is copyright 1993-1996 Russ Taylor                             *
*   ROM has been brought to you by the ROM consortium                      *
*       Russ Taylor (rtaylor@pacinfo.com)                                  *
*       Gabrielle Taylor (gtaylor@pacinfo.com)                             *
*       Brian Moore (rom@rom.efn.org)                                      *
*   By using this code, you have agreed to follow the terms of the         *
*   ROM license, in the file Rom24/doc/rom.license                         *
***************************************************************************/

/***************************************************************************
*   THE LABYRINTH is copyright 1996-2002 Sherene Neil and William          *
*       Wallace                                                            *
*   THE LABYRINTH is brought to you by THE LABYRINTH Team:                 *
*   Sherene Wallace (sherene-dw@comcast.net)                               *
*   William Wallace (williamwallace@comcast.net)                           *
*                                                                          *
*   By using this code, you have agreed to follow the terms of the         *
*   ROM license, in the file Rom24/doc/rom.license                         *
***************************************************************************/

#if defined(macintosh)
#include <types.h>
#elif defined(WIN32)
#include <time.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "merc.h"
#include "recycle.h"
#include "color.h"
#include "tables.h"

/* command procedures needed */
DECLARE_DO_FUN(do_quit	);
DECLARE_DO_FUN(do_sneak	);

/* RT code to delete yourself */

void do_delet( CHAR_DATA *ch, char *argument)
{
    send_to_char("You must type the full command to delete yourself.\n\r",ch);
}

void do_delete( CHAR_DATA *ch, char *argument)
{
   char strsave[MAX_INPUT_LENGTH];

   if (IS_NPC(ch))
	return;

   if (IS_SET(ch->act, PLR_NODELETE)) {
	send_to_char( "You failed.\n\r", ch );
        wiznet("$N was blocked from deleting.",ch,NULL,0,0,get_trust(ch));
	return;
   }
  
   if (ch->pcdata->confirm_delete)
   {
	if (argument[0] != '\0')
	{
	    send_to_char("Delete status removed.\n\r",ch);
	    ch->pcdata->confirm_delete = FALSE;
	    return;
	}
	else
	{
    	    sprintf( strsave, "%s%s", PLAYER_DIR, capitalize( ch->name ) );
	    wiznet("$N turns $Mself into line noise.",ch,NULL,0,0,0);
	    stop_fighting(ch,TRUE);
	    do_quit(ch,"");
	    unlink(strsave);
	    return;
 	}
    }

    if (argument[0] != '\0')
    {
	send_to_char("Just type delete. No argument.\n\r",ch);
	return;
    }

    send_to_char("Type delete again to confirm this command.\n\r",ch);
    send_to_char("WARNING: this command is irreversible.\n\r",ch);
    send_to_char("Typing delete with an argument will undo delete status.\n\r",
	ch);
    ch->pcdata->confirm_delete = TRUE;
    wiznet("$N is contemplating deletion.",ch,NULL,0,0,get_trust(ch));
}
	    

/* RT code to display channel status */
#if 0
void do_channels( CHAR_DATA *ch, char *argument)
{
    char buf[MAX_STRING_LENGTH];

    /* lists all channels and their status */
    send_to_char("   channel     status\n\r",ch);
    send_to_char("---------------------\n\r",ch);
 
    send_to_char("gossip         ",ch);
    if (!IS_SET(ch->comm,COMM_NOGOSSIP))
      send_to_char("ON\n\r",ch);
    else
      send_to_char("OFF\n\r",ch);

    send_to_char("auction        ",ch);
    if (!IS_SET(ch->comm,COMM_NOAUCTION))
      send_to_char("ON\n\r",ch);
    else
      send_to_char("OFF\n\r",ch);

    send_to_char("music          ",ch);
    if (!IS_SET(ch->comm,COMM_NOMUSIC))
      send_to_char("ON\n\r",ch);
    else
      send_to_char("OFF\n\r",ch);

    send_to_char("Q/A            ",ch);
    if (!IS_SET(ch->comm,COMM_NOQUESTION))
      send_to_char("ON\n\r",ch);
    else
      send_to_char("OFF\n\r",ch);

    send_to_char("quote          ",ch);
    if (!IS_SET(ch->comm,COMM_NOQUOTE))
	send_to_char("ON\n\r",ch);
    else
	send_to_char("OFF\n\r",ch);

    send_to_char("grats          ",ch);
    if (!IS_SET(ch->comm,COMM_NOGRATS))
      send_to_char("ON\n\r",ch);
    else
      send_to_char("OFF\n\r",ch);
      
    send_to_char("religion       ",ch);
    if (!IS_SET(ch->comm,COMM_NORELIGION))
      send_to_char("ON\n\r",ch);
    else
      send_to_char("OFF\n\r",ch);

    send_to_char("orate          ",ch);
    if (!IS_SET(ch->comm,COMM_NOORATE))
      send_to_char("ON\n\r",ch);
    else
      send_to_char("OFF\n\r",ch);

    if (IS_IMMORTAL(ch))
    {
      send_to_char("god channel    ",ch);
      if(!IS_SET(ch->comm,COMM_NOWIZ))
        send_to_char("ON\n\r",ch);
      else
        send_to_char("OFF\n\r",ch);
    }
    
    if (get_olc_level(ch) > 1)
    {
      send_to_char("creators       ",ch);
      if(!IS_SET(ch->comm,COMM_NOCRETALK))
        send_to_char("ON\n\r",ch);
      else
        send_to_char("OFF\n\r",ch);
    }

    if (get_trust(ch) >= SUPREME)
    {
      send_to_char("imp channel    ",ch);
      if(!IS_SET(ch->comm,COMM_NOIMP))
        send_to_char("ON\n\r",ch);
      else
        send_to_char("OFF\n\r",ch);
    }

    send_to_char("shouts         ",ch);
    if (!IS_SET(ch->comm,COMM_SHOUTSOFF))
      send_to_char("ON\n\r",ch);
    else
      send_to_char("OFF\n\r",ch);

    send_to_char("tells          ",ch);
    if (!IS_SET(ch->comm,COMM_DEAF))
	send_to_char("ON\n\r",ch);
    else
	send_to_char("OFF\n\r",ch);
	
    send_to_char("tell priority  ",ch);
    if (IS_SET(ch->comm,COMM_PRIORITY))
	send_to_char("ON\n\r",ch);
    else
	send_to_char("OFF\n\r",ch);

    send_to_char("quiet mode     ",ch);
    if (IS_SET(ch->comm,COMM_QUIET))
      send_to_char("ON\n\r",ch);
    else
      send_to_char("OFF\n\r",ch);

    if (IS_SET(ch->comm,COMM_AFK))
	send_to_char("You are AFK.\n\r",ch);

    if (IS_SET(ch->comm,COMM_SNOOP_PROOF))
	send_to_char("You are immune to snooping.\n\r",ch);
   
    if (ch->lines != PAGELEN)
    {
	if (ch->lines)
	{
	    sprintf(buf,"You display %d lines of scroll.\n\r",ch->lines+2);
	    send_to_char(buf,ch);
 	}
	else
	    send_to_char("Scroll buffering is off.\n\r",ch);
    }

    if (ch->prompt != NULL)
    {
	sprintf(buf,"Your current prompt is: %s\n\r",ch->prompt);
	send_to_char(buf,ch);
    }

    if (IS_SET(ch->comm,COMM_NOSHOUT))
      send_to_char("You cannot shout.\n\r",ch);
  
    if (IS_SET(ch->comm,COMM_NOTELL))
      send_to_char("You cannot use tell.\n\r",ch);
 
    if (IS_SET(ch->comm,COMM_NOCHANNELS))
     send_to_char("You cannot use channels.\n\r",ch);

    if (IS_SET(ch->comm,COMM_NOEMOTE))
      send_to_char("You cannot show emotions.\n\r",ch);
}
#endif

/* RT deaf blocks out all shouts */

void do_deaf( CHAR_DATA *ch, char *argument)
{
    
   if (IS_SET(ch->comm,COMM_DEAF))
   {
     send_to_char("You can now hear tells again.\n\r",ch);
     REMOVE_BIT(ch->comm,COMM_DEAF);
   }
   else 
   {
     send_to_char("From now on, you won't hear tells.\n\r",ch);
     SET_BIT(ch->comm,COMM_DEAF);
   }
}

/* RT quiet blocks out all communication */

void do_quiet ( CHAR_DATA *ch, char * argument)
{
    if (IS_SET(ch->comm,COMM_QUIET))
    {
      send_to_char("Quiet mode removed.\n\r",ch);
      REMOVE_BIT(ch->comm,COMM_QUIET);
    }
   else
   {
     send_to_char("From now on, you will only hear says and emotes.\n\r",ch);
     SET_BIT(ch->comm,COMM_QUIET);
   }
}

/* afk command */

void do_afk ( CHAR_DATA *ch, char * argument)
{
    if (IS_SET(ch->comm,COMM_AFK))
    {
      send_to_char("AFK mode removed. Type 'replay' to see tells.\n\r",ch);
      REMOVE_BIT(ch->comm,COMM_AFK);
    }
   else
   {
     send_to_char("You are now in AFK mode.\n\r",ch);
     SET_BIT(ch->comm,COMM_AFK);
   }
}

void do_replay (CHAR_DATA *ch, char *argument)
{
    if (IS_NPC(ch))
    {
	send_to_char("You can't replay.\n\r",ch);
	return;
    }

    if (buf_string(ch->pcdata->buffer)[0] == '\0')
    {
	send_to_char("You have no tells to replay.\n\r",ch);
	return;
    }

    page_to_char(buf_string(ch->pcdata->buffer),ch);
    clear_buf(ch->pcdata->buffer);
}

/* RT auction rewritten in ROM style */
void do_auction( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    DESCRIPTOR_DATA *d;

    if (argument[0] == '\0' )
    {
      if (IS_SET(ch->comm,COMM_NOAUCTION))
      {
	send_to_char("Auction channel is now ON.\n\r",ch);
	REMOVE_BIT(ch->comm,COMM_NOAUCTION);
      }
      else
      {
	send_to_char("Auction channel is now OFF.\n\r",ch);
	SET_BIT(ch->comm,COMM_NOAUCTION);
      }
    }
    else  /* auction message sent, turn auction on if it is off */
    {
	if (IS_SET(ch->comm,COMM_QUIET))
	{
	  send_to_char("You must turn off quiet mode first.\n\r",ch);
	  return;
	}

	if (IS_SET(ch->comm,COMM_NOCHANNELS))
	{
	  send_to_char("The gods have revoked your channel priviliges.\n\r",ch);
	  return;

	REMOVE_BIT(ch->comm,COMM_NOAUCTION);
      }

      sprintf( buf, "You auction '%s'", argument );
      act_color(  buf, ch, NULL, NULL, TO_CHAR, POS_DEAD, C_AUCTION );
      for ( d = descriptor_list; d != NULL; d = d->next )
      {
	CHAR_DATA *victim;

	victim = d->original ? d->original : d->character;

	if ( d->connected == CON_PLAYING &&
	     d->character != ch &&
	     !IS_SET(victim->comm,COMM_NOAUCTION) &&
	     !IS_SET(victim->comm,COMM_QUIET) )
	{
	    act_color("$n auctions '$t'",
	        ch,argument,d->character,TO_VICT,POS_DEAD,C_AUCTION);
 	}
      }
    }
}

/* RT chat replaced with ROM gossip */
void do_gossip( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    DESCRIPTOR_DATA *d;
 
    if (argument[0] == '\0' )
    {
      if (IS_SET(ch->comm,COMM_NOGOSSIP))
      {
        send_to_char("Gossip channel is now ON.\n\r",ch);
        REMOVE_BIT(ch->comm,COMM_NOGOSSIP);
      }
      else
      {
        send_to_char("Gossip channel is now OFF.\n\r",ch);
        SET_BIT(ch->comm,COMM_NOGOSSIP);
      }
    }
    else  /* gossip message sent, turn gossip on if it isn't already */
    {
        if (IS_SET(ch->comm,COMM_QUIET))
        {
          send_to_char("You must turn off quiet mode first.\n\r",ch);
          return;
        }
 
        if (IS_SET(ch->comm,COMM_NOCHANNELS))
        {
          send_to_char("The gods have revoked your channel priviliges.\n\r",ch);
          return;
 
       	}

      REMOVE_BIT(ch->comm,COMM_NOGOSSIP);
 
      sprintf( buf, "You gossip '%s'", argument );
      act_color( buf, ch, NULL, NULL, TO_CHAR, POS_DEAD, C_GOSSIP );
      for ( d = descriptor_list; d != NULL; d = d->next )
      {
        CHAR_DATA *victim;
 
        victim = d->original ? d->original : d->character;
 
        if ( d->connected == CON_PLAYING &&
             d->character != ch &&
             !IS_SET(victim->comm,COMM_NOGOSSIP) &&
             !IS_SET(victim->comm,COMM_QUIET) )
        {
          act_color( "$n gossips '$t'", 
		   ch,argument, d->character, TO_VICT,POS_SLEEPING,C_GOSSIP );
        }
      }
    }
}

void do_grats( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    DESCRIPTOR_DATA *d;
 
    if (argument[0] == '\0' )
    {
      if (IS_SET(ch->comm,COMM_NOGRATS))
      {
        send_to_char("Grats channel is now ON.\n\r",ch);
        REMOVE_BIT(ch->comm,COMM_NOGRATS);
      }
      else
      {
        send_to_char("Grats channel is now OFF.\n\r",ch);
        SET_BIT(ch->comm,COMM_NOGRATS);
      }
    }
    else  /* grats message sent, turn grats on if it isn't already */
    {
        if (IS_SET(ch->comm,COMM_QUIET))
        {
          send_to_char("You must turn off quiet mode first.\n\r",ch);
          return;
        }
 
        if (IS_SET(ch->comm,COMM_NOCHANNELS))
        {
          send_to_char("The gods have revoked your channel priviliges.\n\r",ch);
          return;
 
        }
 
      REMOVE_BIT(ch->comm,COMM_NOGRATS);
 
      sprintf( buf, "You grats '%s'", argument );
      act_color( buf, ch, NULL, NULL, TO_CHAR, POS_DEAD, C_GRATS );
      for ( d = descriptor_list; d != NULL; d = d->next )
      {
        CHAR_DATA *victim;
 
        victim = d->original ? d->original : d->character;
 
        if ( d->connected == CON_PLAYING &&
             d->character != ch &&
             !IS_SET(victim->comm,COMM_NOGRATS) &&
             !IS_SET(victim->comm,COMM_QUIET) )
        {
          act_color( "$n grats '$t'",
                   ch,argument, d->character, TO_VICT,POS_SLEEPING,C_GRATS );
        }
      }
    }
}

void do_quote( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    DESCRIPTOR_DATA *d;
 
    if (argument[0] == '\0' )
    {
      if (IS_SET(ch->comm,COMM_NOQUOTE))
      {
        send_to_char("Quote channel is now ON.\n\r",ch);
        REMOVE_BIT(ch->comm,COMM_NOQUOTE);
      }
      else
      {
        send_to_char("Quote channel is now OFF.\n\r",ch);
        SET_BIT(ch->comm,COMM_NOQUOTE);
      }
    }
    else  /* quote message sent, turn quote on if it isn't already */
    {
        if (IS_SET(ch->comm,COMM_QUIET))
        {
          send_to_char("You must turn off quiet mode first.\n\r",ch);
          return;
        }
 
        if (IS_SET(ch->comm,COMM_NOCHANNELS))
        {
          send_to_char("The gods have revoked your channel priviliges.\n\r",ch);
          return;
 
        }
 
      REMOVE_BIT(ch->comm,COMM_NOQUOTE);
 
      sprintf( buf, "You quote '%s'", argument );
      act_color( buf, ch, NULL, NULL, TO_CHAR, POS_DEAD, C_QUOTE );
      for ( d = descriptor_list; d != NULL; d = d->next )
      {
        CHAR_DATA *victim;
 
        victim = d->original ? d->original : d->character;
 
        if ( d->connected == CON_PLAYING &&
             d->character != ch &&
             !IS_SET(victim->comm,COMM_NOQUOTE) &&
             !IS_SET(victim->comm,COMM_QUIET) )
        {
          act_color( "$n quotes '$t'",
                   ch,argument, d->character, TO_VICT,POS_SLEEPING,C_QUOTE );
        }
      }
    }
}

/* RT question channel */
void do_question( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    DESCRIPTOR_DATA *d;
 
    if (argument[0] == '\0' )
    {
      if (IS_SET(ch->comm,COMM_NOQUESTION))
      {
        send_to_char("Q/A channel is now ON.\n\r",ch);
        REMOVE_BIT(ch->comm,COMM_NOQUESTION);
      }
      else
      {
        send_to_char("Q/A channel is now OFF.\n\r",ch);
        SET_BIT(ch->comm,COMM_NOQUESTION);
      }
    }
    else  /* question sent, turn Q/A on if it isn't already */
    {
        if (IS_SET(ch->comm,COMM_QUIET))
        {
          send_to_char("You must turn off quiet mode first.\n\r",ch);
          return;
        }
 
        if (IS_SET(ch->comm,COMM_NOCHANNELS))
        {
          send_to_char("The gods have revoked your channel priviliges.\n\r",ch);
          return;
	}
 
        REMOVE_BIT(ch->comm,COMM_NOQUESTION);
 
      sprintf( buf, "You question '%s'", argument );
      act_color( buf, ch, NULL, NULL, TO_CHAR, POS_DEAD, C_QUESTION );
      for ( d = descriptor_list; d != NULL; d = d->next )
      {
        CHAR_DATA *victim;
 
        victim = d->original ? d->original : d->character;
 
        if ( d->connected == CON_PLAYING &&
             d->character != ch &&
             !IS_SET(victim->comm, COMM_NOQUESTION) &&
             !IS_SET(victim->comm, COMM_QUIET) )
        {
	  act_color("$n questions '$t'",
	    ch, argument, d->character, TO_VICT, POS_SLEEPING, C_QUESTION);
        } 
      }
    }
}

/* RT answer channel - uses same line as questions */
void do_answer( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    DESCRIPTOR_DATA *d;
 
    if (argument[0] == '\0' )
    {
      if (IS_SET(ch->comm,COMM_NOQUESTION))
      {
        send_to_char("Q/A channel is now ON.\n\r",ch);
        REMOVE_BIT(ch->comm,COMM_NOQUESTION);
      }
      else
      {
        send_to_char("Q/A channel is now OFF.\n\r",ch);
        SET_BIT(ch->comm,COMM_NOQUESTION);
      }
    }
    else  /* answer sent, turn Q/A on if it isn't already */
    {
        if (IS_SET(ch->comm,COMM_QUIET))
        {
          send_to_char("You must turn off quiet mode first.\n\r",ch);
          return;
        }
 
        if (IS_SET(ch->comm,COMM_NOCHANNELS))
        {
          send_to_char("The gods have revoked your channel priviliges.\n\r",ch);
          return;
	}
 
        REMOVE_BIT(ch->comm,COMM_NOQUESTION);
 
      sprintf( buf, "You answer '%s'", argument );
      act_color( buf, ch, NULL, NULL, TO_CHAR, POS_DEAD, C_QUESTION );
      for ( d = descriptor_list; d != NULL; d = d->next )
      {
        CHAR_DATA *victim;
 
        victim = d->original ? d->original : d->character;
 
        if ( d->connected == CON_PLAYING &&
             d->character != ch &&
             !IS_SET(victim->comm,COMM_NOQUESTION) &&
             !IS_SET(victim->comm,COMM_QUIET) )
        {
	  act_color("$n answers '$t'",
		  ch,argument,d->character,TO_VICT,POS_SLEEPING,C_QUESTION);
        }
      }
    }
}

/* RT music channel */
void do_music( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    DESCRIPTOR_DATA *d;
 
    if (argument[0] == '\0' )
    {
      if (IS_SET(ch->comm,COMM_NOMUSIC))
      {
        send_to_char("Music channel is now ON.\n\r",ch);
        REMOVE_BIT(ch->comm,COMM_NOMUSIC);
      }
      else
      {
        send_to_char("Music channel is now OFF.\n\r",ch);
        SET_BIT(ch->comm,COMM_NOMUSIC);
      }
    }
    else  /* music sent, turn music on if it isn't already */
    {
        if (IS_SET(ch->comm,COMM_QUIET))
        {
          send_to_char("You must turn off quiet mode first.\n\r",ch);
          return;
        }
 
        if (IS_SET(ch->comm,COMM_NOCHANNELS))
        {
          send_to_char("The gods have revoked your channel priviliges.\n\r",ch);
          return;
	}
 
        REMOVE_BIT(ch->comm,COMM_NOMUSIC);
 
      sprintf( buf, "You MUSIC: '%s'", argument );
      act_color( buf, ch, NULL, NULL, TO_CHAR, POS_DEAD, C_MUSIC );
      sprintf( buf, "$n MUSIC: '%s'", argument );
      for ( d = descriptor_list; d != NULL; d = d->next )
      {
        CHAR_DATA *victim;
 
        victim = d->original ? d->original : d->character;
 
        if ( d->connected == CON_PLAYING &&
             d->character != ch &&
             !IS_SET(victim->comm,COMM_NOMUSIC) &&
             !IS_SET(victim->comm,COMM_QUIET) )
        {
	    act_color("$n MUSIC: '$t'",
		    ch,argument,d->character,TO_VICT,POS_SLEEPING, C_MUSIC);
        }
      }
    }
}

/* clan channels */
void do_clantalk( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    DESCRIPTOR_DATA *d;

    if (!is_clan(ch) || clan_table[ch->clan].independent)
    {
	send_to_char("You aren't in a clan.\n\r",ch);
	return;
    }
    if ( argument[0] == '\0' )
    {
      if (IS_SET(ch->comm,COMM_NOCLAN))
      {
        send_to_char("Clan channel is now ON\n\r",ch);
        REMOVE_BIT(ch->comm,COMM_NOCLAN);
      }
      else
      {
        send_to_char("Clan channel is now OFF\n\r",ch);
        SET_BIT(ch->comm,COMM_NOCLAN);
      }
      return;
    }

    if (IS_SET(ch->comm,COMM_NOCHANNELS))
    {
         send_to_char("The gods have revoked your channel priviliges.\n\r",ch);
         return;
    }

    REMOVE_BIT(ch->comm,COMM_NOCLAN);

    // rigged for color (to and from), Bri, 31/12/99
    sprintf( buf, "You tell your clan '%s'", argument );
    act_color( buf, ch, NULL, NULL, TO_CHAR, POS_DEAD, C_CLANTALK );
    sprintf( buf, "$n tells the clan '%s'", argument );
    for ( d = descriptor_list; d != NULL; d = d->next )
    {
        if ( d->connected == CON_PLAYING &&
             d->character != ch &&
	     is_same_clan(ch,d->character) &&
             !IS_SET(d->character->comm,COMM_NOCLAN) &&
	     !IS_SET(d->character->comm,COMM_QUIET) )
        {
	    act_color( buf, ch, NULL, d->character, TO_VICT, POS_DEAD, C_CLANTALK );
        }
    }

    return;
}

void do_immtalk( CHAR_DATA *ch, char *argument )
{
    DESCRIPTOR_DATA *d;

    if ( argument[0] == '\0' )
    {
      if (IS_SET(ch->comm,COMM_NOWIZ))
      {
	send_to_char("Immortal channel is now ON\n\r",ch);
	REMOVE_BIT(ch->comm,COMM_NOWIZ);
      }
      else
      {
	send_to_char("Immortal channel is now OFF\n\r",ch);
	SET_BIT(ch->comm,COMM_NOWIZ);
      } 
      return;
    }

    REMOVE_BIT(ch->comm,COMM_NOWIZ);

    act_color("$n: $t",ch,argument,NULL,TO_CHAR,POS_DEAD,C_IMMTALK);
    for ( d = descriptor_list; d != NULL; d = d->next )
    {
	if ( d->connected == CON_PLAYING && 
	     IS_IMMORTAL(d->character) && 
             !IS_SET(d->character->comm,COMM_NOWIZ) )
	{
	    act_color("$n: $t",ch,argument,d->character,TO_VICT,POS_DEAD,C_IMMTALK);
	}
    }

    return;
}


void do_say( CHAR_DATA *ch, char *argument )
{
    if ( argument[0] == '\0' )
    {
	send_to_char( "Say what?\n\r", ch );
	return;
    }

    if ( !IS_AFFECTED2(ch, AFF2_WATER_SPEECH)
    &&   UNDERWATER(ch) )
    {
	act_color( "A stream of bubbles bursts from $n's mouth.", 
	    ch, NULL, argument, TO_ROOM, POS_RESTING, C_SAY );
	act_color( "Glug, glug, glug...", 
	    ch, NULL, NULL, TO_CHAR, POS_RESTING, C_SAY );
	return;
    }

    if ( has_customization(ch, DISADVANTAGE_MUTE) )
    {
        send_to_char( "You're mute, remember?\n\r", ch );
        return;
    }

    act_color( "$n says '$T'", ch, NULL, argument, TO_ROOM,POS_RESTING,C_SAY );
    act_color( "You say '$T'", ch, NULL, argument, TO_CHAR,POS_RESTING,C_SAY );


    if ( !IS_NPC(ch) )
    {
	CHAR_DATA *mob, *mob_next;
	for ( mob = ch->in_room->people; mob != NULL; mob = mob_next )
	{
	    mob_next = mob->next_in_room;
	    if ( IS_NPC(mob) && HAS_TRIGGER( mob, TRIG_SPEECH )
	    &&   mob->position == mob->pIndexData->default_pos )
		mp_act_trigger( argument, mob, ch, NULL, NULL, TRIG_SPEECH );
	}

	if ( !CHAR_KILLED(ch) )
	{
	    if ( ch->in_room->contents != NULL )
		op_speech_trigger( ch, argument );
	    if ( !CHAR_KILLED(ch) )
		rp_speech_trigger( ch, argument );
	}
    }
    return;
}



void do_shout( CHAR_DATA *ch, char *argument )
{
    DESCRIPTOR_DATA *d;

    if (argument[0] == '\0' )
    {
      	if (IS_SET(ch->comm,COMM_SHOUTSOFF))
      	{
            send_to_char("You can hear shouts again.\n\r",ch);
            REMOVE_BIT(ch->comm,COMM_SHOUTSOFF);
      	}
      	else
      	{
            send_to_char("You will no longer hear shouts.\n\r",ch);
            SET_BIT(ch->comm,COMM_SHOUTSOFF);
      	}
      	return;
    }

    if ( IS_SET(ch->comm, COMM_NOSHOUT) )
    {
        send_to_char( "You can't shout.\n\r", ch );
        return;
    }

    if ( has_customization(ch, DISADVANTAGE_MUTE) )
    {
        send_to_char( "You're mute, remember?\n\r", ch );
        return;
    }
 
    REMOVE_BIT(ch->comm,COMM_SHOUTSOFF);

    WAIT_STATE( ch, 12 );

    act_color( "You shout '$T'", ch, NULL, argument, TO_CHAR, POS_DEAD,C_SHOUT);
    for ( d = descriptor_list; d != NULL; d = d->next )
    {
	CHAR_DATA *victim;

	victim = d->original ? d->original : d->character;

	if ( d->connected == CON_PLAYING &&
	     d->character != ch &&
	     !IS_SET(victim->comm, COMM_SHOUTSOFF) &&
	     !IS_SET(victim->comm, COMM_QUIET) ) 
	{
	    act_color("$n shouts '$t'",ch,argument,d->character,TO_VICT,POS_DEAD,C_SHOUT);
	}
    }

    return;
}



void do_tell( CHAR_DATA *ch, char *argument )
{
    char arg[MAX_INPUT_LENGTH],buf[MAX_STRING_LENGTH];
    CHAR_DATA *victim;

    if ( IS_SET(ch->comm, COMM_NOTELL) || IS_SET(ch->comm,COMM_DEAF))
    {
	send_to_char( "Your message didn't get through.\n\r", ch );
	return;
    }

    if ( IS_SET(ch->comm, COMM_QUIET) )
    {
	send_to_char( "You must turn off quiet mode first.\n\r", ch);
	return;
    }

    if (IS_SET(ch->comm,COMM_DEAF))
    {
	send_to_char("You must turn off deaf mode first.\n\r",ch);
	return;
    }

    argument = one_argument( argument, arg );

    if ( arg[0] == '\0' || argument[0] == '\0' )
    {
	send_to_char( "Tell whom what?\n\r", ch );
	return;
    }

    /*
     * Can tell to PC's anywhere, but NPC's only in same room.
     * -- Furey
     */
    if ( ( victim = get_char_world( ch, arg ) ) == NULL
    || ( IS_NPC(victim) && victim->in_room != ch->in_room ) )
    {
	send_to_char( "They aren't here.\n\r", ch );
	return;
    }

    if ( victim->desc == NULL && !IS_NPC(victim))
    {
	act("$N seems to have misplaced $S link...try again later.",
	    ch,NULL,victim,TO_CHAR);
        sprintf(buf,"%s tells you '%s'\n\r",PERS(ch,victim),argument);
        buf[0] = UPPER(buf[0]);
        add_buf(victim->pcdata->buffer,buf);
	return;
    }

    if ( !(IS_IMMORTAL(ch) && ch->level > LEVEL_IMMORTAL) && !IS_AWAKE(victim) )
    {
	act( "$E can't hear you.", ch, 0, victim, TO_CHAR );
	return;
    }
  
    if ((IS_SET(victim->comm,COMM_QUIET) || IS_SET(victim->comm,COMM_DEAF))
    && !IS_IMMORTAL(ch))
    {
	act( "$E is not receiving tells.", ch, 0, victim, TO_CHAR );
  	return;
    }

    if (IS_SET(victim->comm,COMM_AFK))
    {
	if (IS_NPC(victim))
	{
	    act("$E is AFK, and not receiving tells.",ch,NULL,victim,TO_CHAR);
	    return;
	}

	act("$E is AFK, but your tell will go through when $E returns.",
	    ch,NULL,victim,TO_CHAR);
	sprintf(buf,"%s tells you '%s'\n\r",PERS(ch,victim),argument);
	buf[0] = UPPER(buf[0]);
	add_buf(victim->pcdata->buffer,buf);
	return;
    }

    act_color( "You tell $N '$t'", ch, argument, victim, TO_CHAR,POS_DEAD,C_TELL );
    act_color("$n tells you '$t'",ch,argument,victim,TO_VICT,POS_DEAD,C_TELL);
    update_reply( victim, ch );

    if ( !IS_NPC(ch) && IS_NPC(victim) && HAS_TRIGGER(victim,TRIG_SPEECH) )
	mp_act_trigger( argument, victim, ch, NULL, NULL, TRIG_SPEECH );

    return;
}



void do_reply( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    char buf[MAX_STRING_LENGTH];

    if ( IS_SET(ch->comm, COMM_NOTELL) )
    {
	send_to_char( "Your message didn't get through.\n\r", ch );
	return;
    }
    
    if ( ( victim = ch->reply ) == NULL )
    {
	send_to_char( "They aren't here.\n\r", ch );
	return;
    }

    if ( argument[0] == '\0' )
    {
	if ( IS_SET(ch->comm, COMM_PRIORITY) )
	    act( "Your replies are locked onto $N.", 
		ch, NULL, ch->reply, TO_CHAR );
	else
	    act( "Your replies will go to $N.",
		ch, NULL, ch->reply, TO_CHAR );
	
	return;
    }

    if ( victim->desc == NULL && !IS_NPC(victim))
    {
        act("$N seems to have misplaced $S link...try again later.",
            ch,NULL,victim,TO_CHAR);
        sprintf(buf,"%s tells you '%s'\n\r",PERS(ch,victim),argument);
        buf[0] = UPPER(buf[0]);
        add_buf(victim->pcdata->buffer,buf);
        return;
    }

    if ( !IS_IMMORTAL(ch) && !IS_AWAKE(victim) )
    {
	act( "$E can't hear you.", ch, 0, victim, TO_CHAR );
	return;
    }

    if ((IS_SET(victim->comm,COMM_QUIET) || IS_SET(victim->comm,COMM_DEAF))
    &&  !IS_IMMORTAL(ch) && !IS_IMMORTAL(victim))
    {
        act_new( "$E is not receiving tells.", ch, 0, victim, TO_CHAR,POS_DEAD);
        return;
    }

    if (!IS_IMMORTAL(victim) && !IS_AWAKE(ch))
    {
	send_to_char( "In your dreams, or what?\n\r", ch );
	return;
    }

    if (IS_SET(victim->comm,COMM_AFK))
    {
        if (IS_NPC(victim))
        {
            act_new("$E is AFK, and not receiving tells.",
		ch,NULL,victim,TO_CHAR,POS_DEAD);
            return;
        }
 
        act_new("$E is AFK, but your tell will go through when $E returns.",
            ch,NULL,victim,TO_CHAR,POS_DEAD);
        sprintf(buf,"%s tells you '%s'\n\r",PERS(ch,victim),argument);
	buf[0] = UPPER(buf[0]);
        add_buf(victim->pcdata->buffer,buf);
        return;
    }

    act_color("You tell $N '$t'", ch, argument, victim, TO_CHAR,POS_DEAD,C_TELL );
    act_color("$n tells you '$t'",ch,argument,victim,TO_VICT,POS_DEAD,C_TELL);
    update_reply( victim, ch );

    return;
}



void do_yell( CHAR_DATA *ch, char *argument )
{
    DESCRIPTOR_DATA *d;

    if ( IS_SET(ch->comm, COMM_NOSHOUT) )
    {
        send_to_char( "You can't yell.\n\r", ch );
        return;
    }
 
    if ( argument[0] == '\0' )
    {
	send_to_char( "Yell what?\n\r", ch );
	return;
    }

    if ( !IS_AFFECTED2(ch, AFF2_WATER_SPEECH)
    &&   UNDERWATER(ch) )
    {
	act_color( "A stream of bubbles bursts from $n's mouth.", 
	    ch, NULL, argument, TO_ROOM, POS_RESTING, C_SAY );
	act_color( "Glug, glug, glug...", 
	    ch, NULL, NULL, TO_CHAR, POS_RESTING, C_SAY );
	return;
    }

    if ( has_customization(ch, DISADVANTAGE_MUTE) )
    {
        send_to_char( "You're mute, remember?\n\r", ch );
        return;
    }

    act_color("You yell '$t'",ch,argument,NULL,TO_CHAR,POS_DEAD,C_YELL);
    for ( d = descriptor_list; d != NULL; d = d->next )
    {
	if ( d->connected == CON_PLAYING
	&&   d->character != ch
	&&   d->character->in_room != NULL
	&&   d->character->in_room->area == ch->in_room->area 
        &&   !IS_SET(d->character->comm,COMM_QUIET) )
	{
	    act_color("$n yells '$t'",ch,argument,d->character,TO_VICT,
			POS_DEAD,C_YELL);
	}
    }

    return;
}


void do_emote( CHAR_DATA *ch, char *argument )
{
    if ( !IS_NPC(ch) && IS_SET(ch->comm, COMM_NOEMOTE) )
    {
        send_to_char( "You can't show your emotions.\n\r", ch );
        return;
    }
 
    if ( argument[0] == '\0' )
    {
        send_to_char( "Emote what?\n\r", ch );
        return;
    }

    MOBtrigger = FALSE;
    if ( argument[0] == '\'' )
    {
	act( "$n$T", ch, NULL, argument, TO_ROOM );
	act( "$n$T", ch, NULL, argument, TO_CHAR );
    }
    else
    {
	act( "$n $T", ch, NULL, argument, TO_ROOM );
	act( "$n $T", ch, NULL, argument, TO_CHAR );
    }
    MOBtrigger = TRUE;
    return;
}


void do_pmote( CHAR_DATA *ch, char *argument )
{
    char last[MAX_INPUT_LENGTH], temp[MAX_STRING_LENGTH];
    char *letter, *name;
    int matches = 0;
    CHAR_DATA *vch;

    if ( !IS_NPC(ch) && IS_SET(ch->comm, COMM_NOEMOTE) )
    {
        send_to_char( "You can't show your emotions.\n\r", ch );
        return;
    }
 
    if ( argument[0] == '\0' )
    {
        send_to_char( "Emote what?\n\r", ch );
        return;
    }
 
    act( "$n $t", ch, argument, NULL, TO_CHAR );

    for (vch = ch->in_room->people; vch != NULL; vch = vch->next_in_room)
    {
	if (vch->desc == NULL || vch == ch)
	    continue;

	if ((letter = strstr(argument,CHAR_NAME(vch))) == NULL)
	{
	    MOBtrigger = FALSE;
	    act("$N $t",vch,argument,ch,TO_CHAR);
	    MOBtrigger = TRUE;
	    continue;
	}

	strcpy(temp,argument);
	temp[strlen(argument) - strlen(letter)] = '\0';
   	last[0] = '\0';
 	name = CHAR_NAME(vch);
	
	for (; *letter != '\0'; letter++)
	{ 
	    if (*letter == '\'' && matches == strlen(CHAR_NAME(vch)))
	    {
		strcat(temp,"r");
		continue;
	    }

	    if (*letter == 's' && matches == strlen(CHAR_NAME(vch)))
	    {
		matches = 0;
		continue;
	    }
	    
 	    if (matches == strlen(CHAR_NAME(vch)))
	    {
		matches = 0;
	    }

	    if (*letter == *name)
	    {
		matches++;
		name++;
		if (matches == strlen(CHAR_NAME(vch)))
		{
		    strcat(temp,"you");
		    last[0] = '\0';
		    name = CHAR_NAME(vch);
		    continue;
		}
		strncat(last,letter,1);
		continue;
	    }

	    matches = 0;
	    strcat(temp,last);
	    strncat(temp,letter,1);
	    last[0] = '\0';
	    name = CHAR_NAME(vch);
	}

	MOBtrigger = FALSE;
	act("$N $t",vch,temp,ch,TO_CHAR);
	MOBtrigger = TRUE;
    }
	
    return;
}


/*
 * All the posing stuff.
 * Each pair runs in the following order:
 *Mage, clericl, thief, warrior, ranger, ninja, templar, monk, warden, antipaladin, paladin, sorcerer, bard, necromancer, augurer, illusionist.
 */
struct	pose_table_type
{
    char *	message[2*MAX_CLASS];
};

const	struct	pose_table_type	pose_table	[]	=
{
    {
	{
	    "You sizzle with energy.",
	    "$n sizzles with energy.",
	    "You feel very holy.",
	    "$n looks very holy.",
	    "You perform a small card trick.",				
	    "$n performs a small card trick.",
	    "You show your bulging muscles.",
	    "$n shows $s bulging muscles.",
	    "A pleasant aroma drifts up as you brew some Herbal tea.",
	    "A delicious aroma arises as $n starts brewing Herbal tea.",
		"Just for fun you leap from the shadows and thrust a wooden dagger into everyone's back.",
	      "Just for fun $n leaps from the shadows and thrusts a wooden dagger into your back.",
		"Young mothers walk up to thank you for clearing the streets of evil.",
		"Young mothers walk up to $n thanking them for clearing the streets of evil.",
		"You assume the lotus position and begins meditating deeply.",
		"$n assumes the lotus position and begins meditating deeply.",
		"With a shreak and a whistle you become surrounded by all manner of animals.",
		"With a shreak and a whistle $n is surrounded by all manner of animals.",
		"You look around for victims as the power of evil swells in your chest.",
	      "$n looks around for victims as the power of evil swells in them.",
		"Young mothers walk up to thank you for clearing the streets of evil.",
		"Young mothers walk up to $n thanking them for clearing the streets of evil.",
		"You open a window to another plane just for a look around.",
		"$n opens a window to another plane just for a look around.",
		"You strum your harp, hypnotising the room.",
		"You are hypnotised by the melodious melodies of $n's singing.",
		"You mutter some arcane words over your dinner.  Look, a dancing wing!.",
		"Your stomach turns as you see $n animate the fried chicken $s was eating for lunch.",
		"You sit down and begin studying a magical tome.",
	      "$n sits down and begins studying a magical tome.",
		"You wrap yourself in the shadows and vanish.",
	      "$n wraps themself in the shadows and vanishes.",
	}
    },

    {
	{
	    "You turn into a butterfly, then return to your normal shape.",
	    "$n turns into a butterfly, then returns to $s normal shape.",
	    "You nonchalantly turn wine into water.",
	    "$n nonchalantly turns wine into water.",
	    "You wiggle your ears alternately.",                    
	    "$n wiggles $s ears alternately.",
	    "You crack nuts between your fingers.",
	    "$n cracks nuts between $s fingers.",
	    "You cover yourself in twigs, grass and moss, Camouflague!",
	    "$n covers $m in twigs, grass and moss, Camouflague!",
		"With a flick of their wrist you reveal more weapons than a castle armory.",
	      "With a flick of their wrist $n reveals more weapons than a castle armory.",
		"Seeing a poor peasant walk by you fill her arms with food.",
		"Seeing a poor peasant walk by $n fills their arms with food.",
		"Feeling bored you break into a methodical Kata.",
		"Feeling bored $n breaks into a methodical Kata.",
		"You summon a raincloud, which appears and drizzles on everyone except you.",
		"A raincloud appears and drizzles on everyone except $n.",
		"With an evil grin you brandish your unholy symbol.",
	      "With an evil grin $n brandishes their unholy symbol.",
		"Seeing a poor peasant walk by you fills her arms with food.",
		"Seeing a poor peasant walk by $n fills their arms with food.",
		"You mutter something under their breath and the room turns to shadows.",
		"$n mutters something under their breath and the room turns to shadows.",
		"You remove your cap, place it on the ground and begin busking.  Looking for the kind stranger.",
		"$n removes $s cap, places it on the ground and begins busking, perhaps you could spare a few coins?",
		"You begin to study from an ancient tome made of human skin.",
		"$n begins to study from an ancient tome made of human skin.",
		"With a quick incantation your eyes don a mystical glow.",
	      "With a quick incantation $n's eyes don a mystical glow.",
		"You chant to yourself, multipling yourself into a full dozen.",
	      "$n chants to themself and suddenly there are 6 of them.",
	}
    },

    {
	{
	    "Blue sparks fly from your fingers.",
	    "Blue sparks fly from $n's fingers.",
	    "A halo appears over your head.",
	    "A halo appears over $n's head.",
	    "You nimbly tie yourself into a knot.",
	    "$n nimbly ties $mself into a knot.",
	    "You grizzle your teeth and look mean.",
	    "$n grizzles $s teeth and looks mean.",
	    "You part the bushes and appear from seemingly no-where.",
	    "$n parts the bushes and appears from seemingly no-where.",
/*Ninja	"",
*/	      "",
		"You crouch with sword on knee praying for bravery and humility.",
		"$n crouches with sword on knee praying for bravery and humility.",
/*Monk	"",
*/		"",
		"You call to the earth, it mumbles in return, the earth around you trembles for a moment.",
		"$n mumbles something and the earth around you trembles for a moment.",
		"You struggle to maintain the binding spell on the demons within.",
	      "$n struggles to maintain the binding spell on the demons within.",
		"You crouch with sword on knee praying for bravery and humility.",
		"$n crouches with sword on knee praying for bravery and humility.",
/*Sorcerer	"",
*/		"",
		"You part the bushes and appear from seemingly no-where.",
		"$n parts the bushes and appears from seemingly no-where.",
		"As you remove your cloak the stench of death wafts off of you on the gentle breeze.",
		"As $n removes $s cloak you smell the stench of death eminating from them.",
/*Augurer	"",
*/	      "",
/*Illusionist"",
*/	      "",
	}
    },

    {
	{
	    "Little red lights dance in your eyes.",
	    "Little red lights dance in $n's eyes.",
	    "You recite words of wisdom.",
	    "$n recites words of wisdom.",
	    "You juggle with daggers, apples, and eyeballs.",	
	    "$n juggles with daggers, apples, and eyeballs.",
	    "You hit your head, and your eyes roll.",
	    "$n hits $s head, and $s eyes roll.",
	    "With a shreak and a whistle you are surrounded by all manner of animals.",
	    "With a shreak and a whistle $n is surrounded by all manner of animals.",
/*Ninja	"",
*/	      "",
		"You diligently polish the holy symbols on your weapons and armor.",
		"$n diligently polishes the holy symbols on $s weapons and armor.",
/*Monk	"",
*/		"",
		"The ground rises and replicates the shape of you and then turns to dust.",
		"The ground rises and replicates the shape of $n and then turns to dust.",
/*Antipaladin"",
*/	      "",
		"You diligently polish the holy symbols on your weapons and armor.",
		"$n diligently polishes the holy symbols on $s weapons and armor.",
/*Sorcerer	"",
*/	      "",
/*Bard	"",
*/		"",
/*Necromancer"",
*/		 "",
/*Augurer	"",
*/	      "",
/*Illusionist"",
*/	      "",
	}
    },

    {
	{
	    "A slimy green monster appears before you and bows.",
	    "A slimy green monster appears before $n and bows.",
	    "Deep in prayer, you levitate.",
	    "Deep in prayer, $n levitates.",
	    "You steal the underwear off every person in the room.", 
	    "Your underwear is gone!  $n stole it!",
	    "Crunch, crunch -- you munch a bottle.",
	    "Crunch, crunch -- $n munches a bottle.",
/*Ranger  "",
*/	    "",
/*Ninja	"",
*/	      "",
/*Templar	"",
*/		"",
/*Monk	"",
*/		"",
/*Warden	"",
*/	      "",
/*Antipaladin"",
*/	      "",
/*Paladin	"",
*/	      "",
/*Sorcerer	"",
*/	      "",
/*Bard	"",
*/		"",
/*Necromancer"",
*/		 "",
/*Augurer	"",
*/	      "",
/*Illusionist"",
*/	      "",

	}
    },

    {
	{
	    "You turn everybody into a little pink elephant.",
	    "You are turned into a little pink elephant by $n.",
	    "An angel consults you.",
	    "An angel consults $n.",
	    "The dice roll ... and you win again.",		
	    "The dice roll ... and $n wins again.",
	    "... 98, 99, 100 ... you do pushups.",
	    "... 98, 99, 100 ... $n does pushups.",
/*Ranger  "",
*/	    "",
/*Ninja	"",
*/	      "",
/*Templar	"",
*/	      "",
/*Monk	"",
*/		"",
/*Warden	"",
*/	      "",
/*Antipaladin"",
*/	      "",
/*Paladin	"",
*/	      "",
/*Sorcerer	"",
*/	      "",
/*Bard	"",
*/		"",
/*Necromancer"",
*/		 "",
/*Augurer	"",
*/	      "",
/*Illusionist"",
*/	      "",

	}
    },

    {
	{
	    "A small ball of light dances on your fingertips.",
	    "A small ball of light dances on $n's fingertips.",
	    "Your body glows with an unearthly light.",
	    "$n's body glows with an unearthly light.",
	    "You count the money in everyone's pockets.",	
	    "Check your money, $n is counting it.",
	    "Arnold Schwarzenegger admires your physique.",
	    "Arnold Schwarzenegger admires $n's physique.",
/*Ranger  "",
*/	    "",
/*Ninja	"",
*/	      "",
/*Templar	"",
*/		"",
/*Monk	"",
*/		"",
/*Warden	"",
*/	      "",
/*Antipaladin"",
*/	      "",
/*Paladin	"",
*/	      "",
/*Sorcerer	"",
*/	      "",
/*Bard	"",
*/		"",
/*Necromancer"",
*/		 "",
/*Augurer	"",
*/	      "",
/*Illusionist"",
*/	      "",

	}
    },

    {
	{
	    "Smoke and fumes leak from your nostrils.",
	    "Smoke and fumes leak from $n's nostrils.",
	    "A spot light hits you.",
	    "A spot light hits $n.",
	    "You balance a pocket knife on your tongue.",	
	    "$n balances a pocket knife on your tongue.",
	    "Watch your feet, you are juggling granite boulders.",
	    "Watch your feet, $n is juggling granite boulders.",
/*Ranger  "",
*/	    "",
/*Ninja	"",
*/	      "",
/*Templar	"",
*/	      "",
/*Monk	"",
*/		"",
/*Warden	"",
*/	      "",
/*Antipaladin"",
*/	      "",
/*Paladin	"",
*/	      "",
/*Sorcerer	"",
*/	      "",
/*Bard	"",
*/		"",
/*Necromancer"",
*/		 "",
/*Augurer	"",
*/	      "",
/*Illusionist"",
*/	      "",

	}
    },

    {
	{
	    "The light flickers as you rap in magical languages.",
	    "The light flickers as $n raps in magical languages.",
	    "Everyone levitates as you pray.",
	    "You levitate as $n prays.",
	    "You produce a coin from everyone's ear.",		
	    "$n produces a coin from your ear.",
	    "Oomph!  You squeeze water out of a granite boulder.",
	    "Oomph!  $n squeezes water out of a granite boulder.",
/*Ranger  "",
*/	    "",
/*Ninja	"",
*/	      "",
/*Templar	"",
*/	      "",
/*Monk	"",
*/		"",
/*Warden	"",
*/	      "",
/*Antipaladin"",
*/	      "",
/*Paladin	"",
*/	      "",
/*Sorcerer	"",
*/	      "",
/*Bard	"",
*/		"",
/*Necromancer"",
*/		 "",
/*Augurer	"",
*/	      "",
/*Illusionist"",
*/	      "",

	}
    },

    {
	{
	    "Your head disappears.",
	    "$n's head disappears.",
	    "A cool breeze refreshes you.",
	    "A cool breeze refreshes $n.",
	    "You step behind your shadow.",				
	    "$n steps behind $s shadow.",
	    "You pick your teeth with a spear.",
	    "$n picks $s teeth with a spear.",
/*Ranger  "",
*/	    "",
/*Ninja	"",
*/	      "",
/*Templar	"",
*/	      "",
/*Monk	"",
*/		"",
/*Warden	"",
*/	      "",
/*Antipaladin"",
*/	      "",
/*Paladin	"",
*/	      "",
/*Sorcerer	"",
*/	      "",
/*Bard	"",
*/		"",
/*Necromancer"",
*/		 "",
/*Augurer	"",
*/	      "",
/*Illusionist"",
*/	      "",

	}
    },

    {
	{
	    "A fire elemental singes your hair.",
	    "A fire elemental singes $n's hair.",
	    "The sun pierces through the clouds to illuminate you.",
	    "The sun pierces through the clouds to illuminate $n.",
	    "Your eyes dance with greed.",           
	    "$n's eyes dance with greed.",
	    "Everyone is swept off their foot by your hug.",
	    "You are swept off your feet by $n's hug.",
/*Ranger  "",
*/	    "",
/*Ninja	"",
*/	      "",
/*Templar	"",
*/	      "",
/*Monk	"",
*/		"",
/*Warden	"",
*/	      "",
/*Antipaladin"",
*/	      "",
/*Paladin	"",
*/	      "",
/*Sorcerer	"",
*/	      "",
/*Bard	"",
*/		"",
/*Necromancer"",
*/		 "",
/*Augurer	"",
*/	      "",
/*Illusionist"",
*/	      "",

	}
    },

    {
	{
	    "The sky changes color to match your eyes.",
	    "The sky changes color to match $n's eyes.",
	    "The ocean parts before you.",
	    "The ocean parts before $n.",
	    "You deftly steal everyone's weapon.",
	    "$n deftly steals your weapon.",
	    "Your karate chop splits a tree.",
	    "$n's karate chop splits a tree.",
/*Ranger  "",
*/	    "",
/*Ninja	"",
*/	      "",
/*Templar	"",
*/	      "",
/*Monk	"",
*/		"",
/*Warden	"",
*/	      "",
/*Antipaladin"",
*/	      "",
/*Paladin	"",
*/	      "",
/*Sorcerer	"",
*/	      "",
/*Bard	"",
*/		"",
/*Necromancer"",
*/		 "",
/*Augurer	"",
*/	      "",
/*Illusionist"",
*/	      "",

	}
    },

    {
	{
	    "The stones dance to your command.",
	    "The stones dance to $n's command.",
	    "A thunder cloud kneels to you.",
	    "A thunder cloud kneels to $n.",
	    "The Grey Mouser buys you a beer.",		
	    "The Grey Mouser buys $n a beer.",
	    "A strap of your armor breaks over your mighty thews.",
	    "A strap of $n's armor breaks over $s mighty thews.",
/*Ranger  "",
*/	    "",
/*Ninja	"",
*/	      "",
/*Templar	"",
*/	      "",
/*Monk	"",
*/		"",
/*Warden	"",
*/	      "",
/*Antipaladin"",
*/	      "",
/*Paladin	"",
*/	      "",
/*Sorcerer	"",
*/	      "",
/*Bard	"",
*/		"",
/*Necromancer"",
*/		 "",
/*Augurer	"",
*/	      "",
/*Illusionist"",
*/	      "",

	}
    },

    {
	{
	    "The heavens and grass change colour as you smile.",
	    "The heavens and grass change colour as $n smiles.",
	    "The Burning Man speaks to you.",				
	    "The Burning Man speaks to $n.",
	    "Everyone's pocket explodes with your fireworks.",	
	    "Your pocket explodes with $n's fireworks.",
	    "A  cracks at your frown.",					
	    "A boulder cracks at $n's frown.",
/*Ranger  "",
*/	    "",
/*Ninja	"",
*/	      "",
/*Templar	"",
*/	      "",
/*Monk	"",
*/		"",
/*Warden	"",
*/	      "",
/*Antipaladin"",
*/	      "",
/*Paladin	"",
*/	      "",
/*Sorcerer	"",
*/	      "",
/*Bard	"",
*/		"",
/*Necromancer"",
*/		 "",
/*Augurer	"",
*/	      "",
/*Illusionist"",
*/	      "",

	}
    },

    {
	{
	    "Everyone's clothes are transparent, and you are laughing.",
	    "Your clothes are transparent, and $n is laughing.",
	    "An eye in a pyramid winks at you.",
	    "An eye in a pyramid winks at $n.",
	    "Everyone discovers your dagger a centimeter from their eye.",
	    "You discover $n's dagger a centimeter from your eye.",
	    "Mercenaries arrive to do your bidding.",
	    "Mercenaries arrive to do $n's bidding.",
/*Ranger  "",
*/	    "",
/*Ninja	"",
*/	      "",
/*Templar	"",
*/	      "",
/*Monk	"",
*/		"",
/*Warden	"",
*/	      "",
/*Antipaladin"",
*/	      "",
/*Paladin	"",
*/	      "",
/*Sorcerer	"",
*/	      "",
/*Bard	"",
*/		"",
/*Necromancer"",
*/		 "",
/*Augurer	"",
*/	      "",
/*Illusionist"",
*/	      "",

	}
    },

    {
	{
	    "A black hole swallows you.",
	    "A black hole swallows $n.",
	    "Valentine Michael Smith offers you a glass of water.",
	    "Valentine Michael Smith offers $n a glass of water.",
	    "Where did you go?",					
	    "Where did $n go?",
	    "Four matched Percherons bring in your chariot.",
	    "Four matched Percherons bring in $n's chariot.",
/*Ranger  "",
*/	    "",
/*Ninja	"",
*/	      "",
/*Templar	"",
*/	      "",
/*Monk	"",
*/		"",
/*Warden	"",
*/	      "",
/*Antipaladin"",
*/	      "",
/*Paladin	"",
*/	      "",
/*Sorcerer	"",
*/	      "",
/*Bard	"",
*/		"",
/*Necromancer"",
*/		 "",
/*Augurer	"",
*/	      "",
/*Illusionist"",
*/	      "",

	}
    },

    {
	{
	    "The world shimmers in time with your whistling.",
	    "The world shimmers in time with $n's whistling.",
	    "The great god Mota gives you a staff.",
	    "The great god Mota gives $n a staff.",
	    "Click.",
	    "Click.",
	    "Atlas asks you to relieve him.",
	    "Atlas asks $n to relieve him.",
/*Ranger  "",
*/	    "",
/*Ninja	"",
*/	      "",
/*Templar	"",
*/	      "",
/*Monk	"",
*/	      "",
/*Warden	"",
*/	      "",
/*Antipaladin"",
*/	      "",
/*Paladin	"",
*/	      "",
/*Sorcerer	"",
*/	      "",
/*Bard	"",
*/		"",
/*Necromancer"",
*/		 "",
/*Augurer	"",
*/	      "",
/*Illusionist"",
*/	      "",

	}
    }
};



void do_pose( CHAR_DATA *ch, char *argument )
{
    int level;
    int pose;

    if ( IS_NPC(ch) )
	return;

    level = UMIN( ch->level, sizeof(pose_table) / sizeof(pose_table[0]) - 1 );
    pose  = number_range(0, level);

    act( pose_table[pose].message[2*ch->class+0], ch, NULL, NULL, TO_CHAR );
    act( pose_table[pose].message[2*ch->class+1], ch, NULL, NULL, TO_ROOM );

    return;
}


/*
 *void do_bug( CHAR_DATA *ch, char *argument )
 *{
 *    append_file( ch, BUG_FILE, argument );
 *    send_to_char( "Bug logged.\n\r", ch );
 *    return;
 *}
 */

void do_typo( CHAR_DATA *ch, char *argument )
{
    append_file( ch, TYPO_FILE, argument );
    send_to_char( "Typo logged.\n\r", ch );
    return;
}

void do_rent( CHAR_DATA *ch, char *argument )
{
    send_to_char( "There is no rent here.  Just save and quit.\n\r", ch );
    return;
}


void do_qui( CHAR_DATA *ch, char *argument )
{
    send_to_char( "If you want to QUIT, you have to spell it out.\n\r", ch );
    return;
}



void do_quit( CHAR_DATA *ch, char *argument )
{
    DESCRIPTOR_DATA *d,*d_next;
    int id;

    if ( IS_NPC(ch) )
	return;

    if ( ch->fighting != NULL )
    {
	send_to_char( "No way! You are fighting.\n\r", ch );
	return;
    }

    if ( ch->position  < POS_STUNNED  )
    {
	send_to_char( "You're not DEAD yet.\n\r", ch );
	return;
    }
    send_to_char( 
	"And if tomorrow never comes... At least we had today.\n\r",ch);
    act( "$n has left the game.", ch, NULL, NULL, TO_ROOM );
    sprintf( log_buf, "%s has quit.", ch->name );
    log_string( log_buf );
     wiznet("$N wanders back into the real world.",ch,NULL,WIZ_LOGINS,0,get_trust(ch));

    /*
     * After extract_char the ch is no longer valid!
     */
    save_char_obj( ch, TRUE );
    id = ch->id;
    d = ch->desc;
    extract_char( ch, TRUE );
    if ( d != NULL )
	close_socket( d, TRUE );

    /* toast evil cheating bastards */
    for (d = descriptor_list; d != NULL; d = d_next)
    {
	CHAR_DATA *tch;

	d_next = d->next;
	tch = d->original ? d->original : d->character;
	if (tch && tch->id == id)
	{
	    extract_char(tch,TRUE);
	    close_socket(d, FALSE);
	} 
    }

    return;
}



void do_save( CHAR_DATA *ch, char *argument )
{
    if ( IS_NPC(ch) )
	return;

    save_char_obj( ch, FALSE );
    send_to_char("Saving. Remember that The Labyrinth has automatic saving now.\n\r", ch);
    WAIT_STATE(ch,4 * PULSE_VIOLENCE);
    return;
}



void do_follow( CHAR_DATA *ch, char *argument )
{
/* RT changed to allow unlimited following and follow the NOFOLLOW rules */
    char arg[MAX_INPUT_LENGTH];
    CHAR_DATA *victim;

    one_argument( argument, arg );

    if ( arg[0] == '\0' )
    {
	send_to_char( "Follow whom?\n\r", ch );
	return;
    }

    if ( ( victim = get_char_room( ch, arg ) ) == NULL )
    {
	send_to_char( "They aren't here.\n\r", ch );
	return;
    }

    if ( IS_AFFECTED(ch, AFF_CHARM) && ch->master != NULL )
    {
	act( "But you'd rather follow $N!", ch, NULL, ch->master, TO_CHAR );
	return;
    }

    if ( victim == ch )
    {
	if ( ch->master == NULL )
	{
	    send_to_char( "You already follow yourself.\n\r", ch );
	    return;
	}
	stop_follower(ch);
	return;
    }

    if (!IS_NPC(victim) && IS_SET(victim->act,PLR_NOFOLLOW) && !IS_IMMORTAL(ch))
    {
	act("$N doesn't seem to want any followers.\n\r",
             ch,NULL,victim, TO_CHAR);
        return;
    }

    REMOVE_BIT(ch->act,PLR_NOFOLLOW);
    
    if ( ch->master != NULL )
	stop_follower( ch );

    add_follower( ch, victim );
    return;
}


void do_tail( CHAR_DATA *ch, char *argument )
{
    char arg[MAX_INPUT_LENGTH];
    CHAR_DATA *victim;
    int chance;

    one_argument( argument, arg );

    if ( (chance = get_skill(ch,gsn_tail)) == 0
    ||   (!IS_NPC(ch) 
	  && ch->level < skill_level(ch, gsn_tail)) )
    {
	send_to_char("You don't know how.\n\r",ch);
	return;
    }

    if ( arg[0] == '\0' )
    {
	send_to_char( "Tail whom?\n\r", ch );
	return;
    }

    if ( ( victim = get_char_room( ch, arg ) ) == NULL )
    {
	send_to_char( "They aren't here.\n\r", ch );
	return;
    }

    if ( IS_AFFECTED(ch, AFF_CHARM) && ch->master != NULL )
    {
	act( "But you'd rather follow $N!", ch, NULL, ch->master, TO_CHAR );
	return;
    }

    if ( victim == ch )
    {
	send_to_char( "You can't tail yourself!\n\r", ch );
	return;
    }

    if ( IS_NPC(victim) && !IS_IMMORTAL(ch) )
    {
	act( "$N wouldn't like that.\n\r", ch, NULL, victim, TO_CHAR );
        return;
    }

    REMOVE_BIT( ch->act, PLR_NOFOLLOW );
    
    if ( !IS_AFFECTED(ch, AFF_SNEAK) )
	do_sneak( ch, "" );

    if ( can_see(victim, ch) )
	chance = chance - get_curr_stat(victim, STAT_PER) / 4;
    chance = URANGE( 5, chance, 95 );
    
    /* if they failed */
    if ( number_percent() >= chance )
    {
        /* if they realise they've failed */
    	if ( number_percent() < chance )
    	{
    	    act( "$N seems too alert to tail.", ch, NULL, victim, TO_CHAR );
    	    return;
    	}
    	else if ( number_percent() < get_curr_stat(victim, STAT_PER)/4 )
    	{
    	    act( "$n starts to tail you!", ch, NULL, victim, TO_VICT );
    	}
    }
    else
    	check_improve( ch, gsn_tail, TRUE, 1, TRUE );

    if ( ch->master != NULL )
	stop_follower( ch );
    
    ch->master = victim;
    ch->leader = NULL;
    
    act( "You start to tail $N.", ch, NULL, victim, TO_CHAR );
    return;
}


void add_follower( CHAR_DATA *ch, CHAR_DATA *master )
{
    if ( ch->master != NULL )
    {
	bug( "Add_follower: non-null master.", 0 );
	return;
    }

    ch->master        = master;
    ch->leader        = NULL;

    if ( can_see( master, ch ) )
	act( "$n now follows you.", ch, NULL, master, TO_VICT );

    act( "You now follow $N.",  ch, NULL, master, TO_CHAR );

    return;
}



void stop_follower( CHAR_DATA *ch )
{
    if ( ch->master == NULL )
    {
	bug( "Stop_follower: null master.", 0 );
	return;
    }

    if ( IS_AFFECTED(ch, AFF_CHARM) )
    {
	REMOVE_BIT( ch->affected_by, AFF_CHARM );
	affect_strip( ch, gsn_charm_person );
	affect_strip( ch, gsn_befriend );
    }

    if ( can_see( ch->master, ch ) && ch->in_room != NULL)
    {
	act( "$n stops following you.",     ch, NULL, ch->master, TO_VICT    );
    	act( "You stop following $N.",      ch, NULL, ch->master, TO_CHAR    );
    }
    if (ch->master->pet == ch)
	ch->master->pet = NULL;

    ch->master = NULL;
    ch->leader = NULL;
    return;
}

/* nukes charmed monsters and pets */
void nuke_pets( CHAR_DATA *ch )
{    
    CHAR_DATA *pet;

    if ((pet = ch->pet) != NULL)
    {
    	stop_follower(pet);
    	if (pet->in_room != NULL)
    	    act("$N slowly fades away.",ch,NULL,pet,TO_NOTVICT);
    	extract_char(pet,TRUE);
    }
    ch->pet = NULL;

    return;
}



void die_follower( CHAR_DATA *ch )
{
    CHAR_DATA *fch;

    if ( ch->master != NULL )
    {
	if (ch->master->pet == ch)
	    ch->master->pet = NULL;
	stop_follower( ch );
    }

    ch->leader = NULL;

    for ( fch = char_list; fch != NULL; fch = fch->next )
    {
	if ( fch->master == ch )
	    stop_follower( fch );
	if ( fch->leader == ch )
	    fch->leader = fch;
    }

    return;
}



void do_order( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    char arg[MAX_INPUT_LENGTH],arg2[MAX_INPUT_LENGTH];
    bool captainsOrder = FALSE;
    CHAR_DATA *victim;
    CHAR_DATA *och;
    CHAR_DATA *och_next;
    bool found;
    bool fAll;

    argument = one_argument( argument, arg );
    one_argument(argument,arg2);

    if ( has_customization(ch, DISADVANTAGE_MUTE) )
    {
        send_to_char( "You're mute, remember?\n\r", ch );
        return;
    }

    if (!str_cmp(arg2,"delete") || !str_cmp(arg2,"mc"))
    {
        send_to_char("That will NOT be done.\n\r",ch);
        return;
    }

    if ( arg[0] == '\0' || argument[0] == '\0' )
    {
	send_to_char( "Order whom to do what?\n\r", ch );
	return;
    }

    if ( IS_AFFECTED( ch, AFF_CHARM ) )
    {
	send_to_char( "You feel like taking, not giving, orders.\n\r", ch );
	return;
    }

    if ( !str_cmp( arg, "all" ) )
    {
	fAll   = TRUE;
	victim = NULL;
    }
    else
    {
	fAll   = FALSE;
	if ( ( victim = get_char_room( ch, arg ) ) == NULL )
	{
	    send_to_char( "They aren't here.\n\r", ch );
	    return;
	}

	if ( victim == ch )
	{
	    send_to_char( "Aye aye, right away!\n\r", ch );
	    return;
	}

	if ( !IS_AFFECTED(victim, AFF_CHARM) || victim->master != ch 
	||   (IS_IMMORTAL(victim) && victim->trust >= ch->trust) )
	{  
            if ( !IS_NPC(victim)
            ||   !IS_SET(victim->act, ACT_GUARD)
            ||   !(has_territory_flag(ch, victim->pIndexData->area->territory, TERR_CAPTAIN_GUARD)
            ||     (!IS_NPC(ch)
            &&      ch->pcdata->social_classes[victim->pIndexData->area->territory] == MAX_SOCIAL_CLASS - 1)) )
            {
	        send_to_char( "Do it yourself!\n\r", ch );
	        return;
            }

            if ( !str_cmp(arg2, "follow") || !str_cmp(arg2, "mc") )
            {
                send_to_char("That will NOT be done.\n\r",ch);
                return;
            }
            captainsOrder = TRUE;
	}
    }

    found = FALSE;
    for ( och = ch->in_room->people; och != NULL; och = och_next )
    {
	och_next = och->next_in_room;

	if ( (IS_AFFECTED(och, AFF_CHARM)
	&&    och->master == ch
        &&    (fAll || och == victim) )
        ||   (captainsOrder
        &&    IS_NPC(och)
        &&    IS_SET(och->act, ACT_GUARD)
        &&    och == victim) )
	{
	    AFFECT_DATA *paf;
	    int level = 10;

	    found = TRUE;

	    if ( !IS_NPC(och)
	    ||   (!IS_SET(och->act, ACT_PET)
	    &&    !IS_AFFECTED2(och, AFF2_DOMINATION)
            &&    !captainsOrder) )
	    {
		paf = affect_find( och->affected, gsn_charm_person );
		if ( paf == NULL )
		    paf = affect_find( och->affected, gsn_befriend );
	
		if ( paf != NULL )
		    level += paf->level;
	
		level = level + (10 * och->hit) / och->max_hit - 10;
		if ( (IS_GOOD(och)
		&&    IS_EVIL(ch)
		&&    IS_AFFECTED(och, AFF_DETECT_EVIL)
		&&    !IS_AFFECTED2(ch, AFF2_DELUDE))
		||   (IS_EVIL(och)
		&&    IS_GOOD(ch)
		&&    IS_AFFECTED(och, AFF_DETECT_GOOD)
		&&    !IS_AFFECTED2(ch, AFF2_DELUDE)) )
		    level -= 5;
	    
		if ( saves_spell(level, och, DAM_CHARM) )
		{
		    send_to_char( "You regain your free will.\n\r", och );
		    act( "$N regains $S free will.", 
		        ch, NULL, och, TO_CHAR );

		    REMOVE_BIT( och->affected_by, AFF_CHARM );
		    affect_strip( och, gsn_charm_person );
		    affect_strip( och, gsn_befriend );

		    if ( saves_spell(level + 
		                        get_curr_stat(och, STAT_INT)/10 - 5,
		                     och, DAM_CHARM) )
			multi_hit( och, ch, TYPE_UNDEFINED );

		    continue;
		}
	    }

            if ( captainsOrder )
            {
                sprintf( buf, "%s, %s, orders %s to %s",
                    (has_territory_flag(ch, och->pIndexData->area->territory, TERR_CAPTAIN_GUARD)
                      ? "Captain of the guard"
                      : "Territory ruler"),
                    ch->name, och->short_descr, argument );
	        wiznet( buf, ch, NULL, WIZ_MOBACTIONS, 0, get_trust(ch) );
                log_string( buf );
            }

	    sprintf( buf, "$n orders you to '%s'.", argument );
	    act( buf, ch, NULL, och, TO_VICT );
	    interpret( och, argument );
	}

    }

    if ( found )
    {
	WAIT_STATE(ch,PULSE_VIOLENCE);
	send_to_char( "Ok.\n\r", ch );
    }
    else
	send_to_char( "You have no followers here.\n\r", ch );
    return;
}



void do_group( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    char arg[MAX_INPUT_LENGTH];
    CHAR_DATA *victim;

    one_argument( argument, arg );

    if ( arg[0] == '\0' )
    {
	CHAR_DATA *gch;
	CHAR_DATA *leader;

	leader = (ch->leader != NULL) ? ch->leader : ch;
	sprintf( buf, "%s's group:\n\r", PERS(leader, ch) );
	send_to_char( buf, ch );

	for ( gch = char_list; gch != NULL; gch = gch->next )
	{
	    if ( is_same_group( gch, ch ) )
	    {
		sprintf( buf,
		"[%2d %s] %-16s %4d/%4d hp %4d/%4d mana %4d/%4d mv %5d xp\n\r",
		    gch->level,
		    IS_NPC(gch) ? "Mob" : class_table[gch->class].who_name,
		    capitalize( PERS(gch, ch) ),
		    gch->hit,   gch->max_hit,
		    gch->mana,  gch->max_mana,
		    gch->move,  gch->max_move,
		    gch->exp    );
		send_to_char( buf, ch );
	    }
	}
	return;
    }

    if ( ( victim = get_char_room( ch, arg ) ) == NULL )
    {
	send_to_char( "They aren't here.\n\r", ch );
	return;
    }

    if ( ch->master != NULL || ( ch->leader != NULL && ch->leader != ch ) )
    {
	send_to_char( "But you are following someone else!\n\r", ch );
	return;
    }

    if ( victim->master != ch && ch != victim )
    {
	act_new("$N isn't following you.",ch,NULL,victim,TO_CHAR,POS_SLEEPING);
	return;
    }
    
    if (IS_AFFECTED(victim,AFF_CHARM))
    {
        send_to_char("You can't remove charmed mobs from your group.\n\r",ch);
        return;
    }
    
    if (IS_AFFECTED(ch,AFF_CHARM))
    {
    	act_new("You like your master too much to leave $m!",
	    ch,NULL,victim,TO_VICT,POS_SLEEPING);
    	return;
    }

    if ( is_same_group( victim, ch ) && ch != victim )
    {
	victim->leader = NULL;
	act_new("$n removes $N from $s group.",
	    ch,NULL,victim,TO_NOTVICT,POS_RESTING);
	act_new("$n removes you from $s group.",
	    ch,NULL,victim,TO_VICT,POS_SLEEPING);
	act_new("You remove $N from your group.",
	    ch,NULL,victim,TO_CHAR,POS_SLEEPING);
	return;
    }

    victim->leader = ch;
    act_new("$N joins $n's group.",ch,NULL,victim,TO_NOTVICT,POS_RESTING);
    act_new("You join $n's group.",ch,NULL,victim,TO_VICT,POS_SLEEPING);
    act_new("$N joins your group.",ch,NULL,victim,TO_CHAR,POS_SLEEPING);
    return;
}



/*
 * 'Split' originally by Gnort, God of Chaos.
 */
void do_split( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    char arg1[MAX_INPUT_LENGTH],arg2[MAX_INPUT_LENGTH];
    CHAR_DATA *gch;
    int members;
    int amount_gold = 0, amount_silver = 0;
    int share_gold, share_silver;
    int extra_gold, extra_silver;

    argument = one_argument( argument, arg1 );
	       one_argument( argument, arg2 );

    if ( arg1[0] == '\0' )
    {
	send_to_char( "Split how much?\n\r", ch );
	return;
    }
    
    amount_silver = atoi( arg1 );

    if (arg2[0] != '\0')
	amount_gold = atoi(arg2);

    if ( amount_gold < 0 || amount_silver < 0)
    {
	send_to_char( "Your group wouldn't like that.\n\r", ch );
	return;
    }

    if ( amount_gold == 0 && amount_silver == 0 )
    {
	send_to_char( "You hand out zero coins, but no one notices.\n\r", ch );
	return;
    }

    if ( ch->gold <  amount_gold || ch->silver < amount_silver)
    {
	send_to_char( "You don't have that much to split.\n\r", ch );
	return;
    }
  
    members = 0;
    for ( gch = ch->in_room->people; gch != NULL; gch = gch->next_in_room )
    {
	if ( is_same_group( gch, ch ) && !IS_AFFECTED(gch,AFF_CHARM))
	    members++;
    }

    if ( members < 2 )
    {
	send_to_char( "Just keep it all.\n\r", ch );
	return;
    }
	    
    share_silver = amount_silver / members;
    extra_silver = amount_silver % members;

    share_gold   = amount_gold / members;
    extra_gold   = amount_gold % members;

    if ( share_gold == 0 && share_silver == 0 )
    {
	send_to_char( "Don't even bother, cheapskate.\n\r", ch );
	return;
    }

    ch->silver	-= amount_silver;
    ch->silver	+= share_silver + extra_silver;
    ch->gold 	-= amount_gold;
    ch->gold 	+= share_gold + extra_gold;

    if (share_silver > 0)
    {
	sprintf(buf,
	    "You split %d silver coins. Your share is %d silver.\n\r",
 	    amount_silver,share_silver + extra_silver);
	send_to_char(buf,ch);
    }

    if (share_gold > 0)
    {
	sprintf(buf,
	    "You split %d gold coins. Your share is %d gold.\n\r",
	     amount_gold,share_gold + extra_gold);
	send_to_char(buf,ch);
    }

    if (share_gold == 0)
    {
	sprintf(buf,"$n splits %d silver coins. Your share is %d silver.",
		amount_silver,share_silver);
    }
    else if (share_silver == 0)
    {
	sprintf(buf,"$n splits %d gold coins. Your share is %d gold.",
		amount_gold,share_gold);
    }
    else
    {
	sprintf(buf,
"$n splits %d silver and %d gold coins, giving you %d silver and %d gold.\n\r",
	 amount_silver,amount_gold,share_silver,share_gold);
    }

    for ( gch = ch->in_room->people; gch != NULL; gch = gch->next_in_room )
    {
	if ( gch != ch && is_same_group(gch,ch) && !IS_AFFECTED(gch,AFF_CHARM))
	{
	    act( buf, ch, NULL, gch, TO_VICT );
	    gch->gold += share_gold;
	    gch->silver += share_silver;
	}
    }

    return;
}



void do_gtell( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    CHAR_DATA *gch;

    if ( argument[0] == '\0' )
    {
	send_to_char( "Tell your group what?\n\r", ch );
	return;
    }

    if ( IS_SET( ch->comm, COMM_NOTELL ) )
    {
	send_to_char( "Your message didn't get through!\n\r", ch );
	return;
    }

    sprintf( buf, "%s tells the group '%s'", CHAR_NAME(ch), argument );
    for ( gch = char_list; gch != NULL; gch = gch->next )
    {
	if (( is_same_group( gch, ch )) && gch != ch )
		 act_color( buf, gch, NULL, NULL, TO_CHAR, POS_SLEEPING, C_GROUPTELL );
    }

    sprintf( buf, "You tell the group '%s'", argument );
    act_color( buf, ch, NULL, NULL, TO_CHAR, POS_SLEEPING, C_GROUPTELL );

    return;
}



/*
 * It is very important that this be an equivalence relation:
 * (1) A ~ A
 * (2) if A ~ B then B ~ A
 * (3) if A ~ B  and B ~ C, then A ~ C
 */
bool is_same_group( CHAR_DATA *ach, CHAR_DATA *bch )
{
    if ( ach == NULL || bch == NULL)
	return FALSE;

    if ( ach->leader != NULL ) ach = ach->leader;
    if ( bch->leader != NULL ) bch = bch->leader;
    return ach == bch;
}


void do_imptalk( CHAR_DATA *ch, char *argument )
{
    DESCRIPTOR_DATA *d;

    if ( argument[0] == '\0' )
    {
      if (IS_SET(ch->comm,COMM_NOIMP))
      {
	send_to_char("Implementor channel is now ON\n\r",ch);
	REMOVE_BIT(ch->comm,COMM_NOIMP);
      }
      else
      {
	send_to_char("Implementor channel is now OFF\n\r",ch);
	SET_BIT(ch->comm,COMM_NOIMP);
      } 
      return;
    }

    REMOVE_BIT(ch->comm,COMM_NOIMP);

    act_color("$n> $t",ch,argument,NULL,TO_CHAR,POS_DEAD,C_IMPTALK);
    for ( d = descriptor_list; d != NULL; d = d->next )
    {
	if ( d->connected == CON_PLAYING && 
	     get_trust(d->character) >= SUPREME && 
             !IS_SET(d->character->comm,COMM_NOIMP) )
	{
	    act_color("$n> $t",ch,argument,d->character,TO_VICT,POS_DEAD,C_IMPTALK);
	}
    }

    return;
}


void do_religion( CHAR_DATA *ch, char *argument )
{
    DESCRIPTOR_DATA *d;
    int religion;
    int heresy;

    if ( argument[0] == '\0' )
    {
      if (IS_SET(ch->comm,COMM_NORELIGION))
      {
	send_to_char("Religion channel is now ON\n\r",ch);
	REMOVE_BIT(ch->comm,COMM_NORELIGION);
      }
      else
      {
	send_to_char("Religion channel is now OFF\n\r",ch);
	SET_BIT(ch->comm,COMM_NORELIGION);
      } 
      return;
    }
    else
    {
	if (IS_SET(ch->comm,COMM_QUIET))
	{
	    send_to_char("You must turn off quiet mode first.\n\r",ch);
	    return;
	}

	if (IS_SET(ch->comm,COMM_NOCHANNELS))
	{
	    send_to_char("The gods have revoked your channel priviliges.\n\r",ch);
	    return;
	}

	if ( IS_NPC(ch)
	&&   ch->desc
	&&   ch->desc->original
	&&   ch->desc->original->pcdata )
	{
	    religion	= ch->desc->original->pcdata->religion;
	    heresy	= ch->desc->original->pcdata->heresy;
	}
	else
	{
	    if ( IS_NPC(ch) )
		heresy = 0;
	    else
		heresy = ch->pcdata->heresy;

	    religion = GET_GOD( ch );
	}

	if ( heresy >= HERESY_NOCHANNEL )
	{
	    send_to_char( "Heretics are not permitted this channel.\n\r", ch );
	    return;
	}

	REMOVE_BIT(ch->comm,COMM_NORELIGION);

	act_color("You tell the brethren '$t'",
	    ch,argument,NULL,TO_CHAR,POS_DEAD,C_RELIGION);
	for ( d = descriptor_list; d != NULL; d = d->next )
	{
	    CHAR_DATA *victim;
	
	    victim = d->original ? d->original : d->character;
	
	    if ( d->connected == CON_PLAYING
	    &&   d->character != ch
	    &&   religion == GET_GOD(victim)
	    &&   !IS_SET(victim->comm, COMM_NORELIGION)
	    &&   victim->pcdata->heresy < HERESY_NOCHANNEL )
		act_color( "$n tells the brethren '$t'",
		    ch, argument, d->character, TO_VICT, POS_DEAD, C_RELIGION );
	}
    }

    return;
}


void do_intone( CHAR_DATA *ch, char *argument )
{
    DESCRIPTOR_DATA *d;

    act_new("You intone '$t'",ch,argument,NULL,TO_CHAR,POS_DEAD);
    for ( d = descriptor_list; d != NULL; d = d->next )
    {
	if ( d->connected == CON_PLAYING )
	{
	    act_new("$n intones '$t'",ch,argument,d->character,TO_VICT,POS_DEAD);
	}
    }

    return;
}


void do_boom( CHAR_DATA *ch, char *argument )
{
    DESCRIPTOR_DATA *d;

    act_new("You boom '$t'",ch,argument,NULL,TO_CHAR,POS_DEAD);
    for ( d = descriptor_list; d != NULL; d = d->next )
    {
	if ( d->connected == CON_PLAYING )
	{
	    act_new("$n booms '$t'",ch,argument,d->character,TO_VICT,POS_DEAD);
	}
    }

    return;
}


/* Update the reply field of ch taking into account priority. */
void update_reply( CHAR_DATA* ch, CHAR_DATA *to )
{
    if ( !IS_SET(ch->comm, COMM_PRIORITY) )
	ch->reply = to;
    else if ( ch->reply == NULL )
    {
	ch->reply = to;
	act( "Replies locked to $N.", ch, NULL, ch->reply, TO_CHAR );
    }
}


void do_priority( CHAR_DATA *ch, char *argument )
{
    if ( IS_SET(ch->comm, COMM_PRIORITY) )
    {
	REMOVE_BIT( ch->comm, COMM_PRIORITY );
	send_to_char( "You replies are now unlocked.\n\r", ch );
    }
    else
    {
	SET_BIT( ch->comm, COMM_PRIORITY );
	if ( ch->reply == NULL )
	    send_to_char( "Reply priority set.\n\r", ch );
	else
	    act( "Replies locked to $N.", ch, NULL, ch->reply, TO_CHAR );
    }
}


void do_whisper( CHAR_DATA *ch, char *argument )
{
    if ( argument[0] == '\0' )
    {
	send_to_char( "Whisper what?\n\r", ch );
	return;
    }

    if ( !IS_AFFECTED2(ch, AFF2_WATER_SPEECH)
    &&   UNDERWATER(ch) )
    {
	act_color( "A stream of bubbles bursts from $n's mouth.", 
	    ch, NULL, argument, TO_ROOM, POS_RESTING, C_SAY );
	act_color( "Glug, glug, glug...", 
	    ch, NULL, NULL, TO_CHAR, POS_RESTING, C_SAY );
	return;
    }

    if ( has_customization(ch, DISADVANTAGE_MUTE) )
    {
        send_to_char( "You're mute, remember?\n\r", ch );
        return;
    }

    act( "$n whispers '$T'", ch, NULL, argument, TO_ROOM );
    act( "You whisper '$T'", ch, NULL, argument, TO_CHAR );
    return;
}


void do_murmur( CHAR_DATA *ch, char *argument )
{
    if ( argument[0] == '\0' )
    {
	send_to_char( "Murmur what?\n\r", ch );
	return;
    }

    if ( !IS_AFFECTED2(ch, AFF2_WATER_SPEECH)
    &&   UNDERWATER(ch) )
    {
	act_color( "A stream of bubbles bursts from $n's mouth.", 
	    ch, NULL, argument, TO_ROOM, POS_RESTING, C_SAY );
	act_color( "Glug, glug, glug...", 
	    ch, NULL, NULL, TO_CHAR, POS_RESTING, C_SAY );
	return;
    }

    if ( has_customization(ch, DISADVANTAGE_MUTE) )
    {
        send_to_char( "You're mute, remember?\n\r", ch );
        return;
    }

    act( "$n murmurs '$T'", ch, NULL, argument, TO_ROOM );
    act( "You murmur '$T'", ch, NULL, argument, TO_CHAR );
    return;
}


void do_cretalk( CHAR_DATA *ch, char *argument )
{
    DESCRIPTOR_DATA *d;

    if ( argument[0] == '\0' )
    {
      if (IS_SET(ch->comm,COMM_NOCRETALK))
      {
	send_to_char("Creator channel is now ON\n\r",ch);
	REMOVE_BIT(ch->comm,COMM_NOCRETALK);
      }
      else
      {
	send_to_char("Creator channel is now OFF\n\r",ch);
	SET_BIT(ch->comm,COMM_NOCRETALK);
      } 
      return;
    }

    REMOVE_BIT(ch->comm,COMM_NOCRETALK);

    act_color("$n] $t",ch,argument,NULL,TO_CHAR,POS_DEAD,C_CRETALK);
    for ( d = descriptor_list; d != NULL; d = d->next )
    {
	if ( d->connected == CON_PLAYING && 
	     (get_olc_level(d->character) > 1) && 
             !IS_SET(d->character->comm,COMM_NOCRETALK) )
	{
	    act_color("$n] $t",ch,argument,d->character,TO_VICT,POS_DEAD,C_CRETALK);
	}
    }

    return;
}


void do_orate( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    DESCRIPTOR_DATA *d;
 
    if (argument[0] == '\0' )
    {
	if (IS_SET(ch->comm,COMM_NOORATE))
	{
	    send_to_char("Orate channel is now ON.\n\r",ch);
	    REMOVE_BIT(ch->comm,COMM_NOORATE);
	}
	else
	{
	    send_to_char("Orate channel is now OFF.\n\r",ch);
	    SET_BIT(ch->comm,COMM_NOORATE);
	}
    }
    else  /* orate message sent, turn orate on if it isn't already */
    {
	if (IS_SET(ch->comm,COMM_QUIET))
	{
	    send_to_char("You must turn off quiet mode first.\n\r",ch);
	    return;
	}
 
	if (IS_SET(ch->comm,COMM_NOCHANNELS))
	{
	    send_to_char("The gods have revoked your channel priviliges.\n\r",ch);
	    return;
	}

	REMOVE_BIT(ch->comm,COMM_NOORATE);
 
	sprintf( buf, "You orate '%s'", argument );
	act_color( buf, ch, NULL, NULL, TO_CHAR, POS_DEAD, C_ORATE );
	for ( d = descriptor_list; d != NULL; d = d->next )
	{
	    CHAR_DATA *victim;
 
	    victim = d->original ? d->original : d->character;
 
	    if ( d->connected == CON_PLAYING
	    &&   d->character != ch
	    &&   !IS_SET(victim->comm,COMM_NOORATE)
	    &&   !IS_SET(victim->comm,COMM_QUIET) )
	    {
		act_color( "$n orates '$t'",
		   ch, argument, d->character, TO_VICT,
		   POS_SLEEPING, C_ORATE );
	    }
	}
    }
}

/*
// Gocial by Criadito, 5 Feb 01. Based on an idea from AotC MUD.
void do_gocial( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    int iSocial;
    int col;

    col = 0;

    if ( !IS_NPC(ch) && IS_SET(ch->comm, COMM_NOGOCIAL) )
    {
        send_to_char( "You can't show your emotions.\n\r", ch );
        return;
    }
 
    if (IS_SET(ch->comm,COMM_QUIET))
    {
        send_to_char("You must turn off quiet mode first.\n\r",ch);
        return;
    }

    if ( argument[0] == '\0' )
    {
        send_to_char( "Gocial what?\n\r", ch );
        return;
    }

    REMOVE_BIT(ch->comm,COMM_NOGOCIAL);

    sprintf( buf, "Gocial: 

    MOBtrigger = FALSE;
    if ( argument[0] == '\'' )
    {
	act( "$n$T", ch, NULL, argument, TO_ROOM );
	act( "$n$T", ch, NULL, argument, TO_CHAR );
    }
    else
    {
	act( "$n $T", ch, NULL, argument, TO_ROOM );
	act( "$n $T", ch, NULL, argument, TO_CHAR );
    }
    MOBtrigger = TRUE;
    return;
}
*/


