/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 ***************************************************************************/

/***************************************************************************
*   ROM 2.4 is copyright 1993-1996 Russ Taylor                             *
*   ROM has been brought to you by the ROM consortium                      *
*       Russ Taylor (rtaylor@pacinfo.com)                                  *
*       Gabrielle Taylor (gtaylor@pacinfo.com)                             *
*       Brian Moore (rom@rom.efn.org)                                      *
*   By using this code, you have agreed to follow the terms of the         *
*   ROM license, in the file Rom24/doc/rom.license                         *
***************************************************************************/

/***************************************************************************
*   THE LABYRINTH is copyright 1996-2002 Sherene Neil and William          *
*       Wallace                                                            *
*   THE LABYRINTH is brought to you by THE LABYRINTH Team:                 *
*   Sherene Wallace (sherene-dw@comcast.net)                               *
*   William Wallace (williamwallace@comcast.net)                           *
*                                                                          *
*   By using this code, you have agreed to follow the terms of the         *
*   ROM license, in the file Rom24/doc/rom.license                         *
***************************************************************************/

/*
 * Lore written by Talis.
 */

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <time.h>
#include "merc.h"
#include "magic.h"
#include "interp.h"

void lore_crit_success ( CHAR_DATA *ch, char *item, OBJ_DATA *obj)
{
    char buf[MAX_STRING_LENGTH];
    AFFECT_DATA *paf;

    sprintf( buf, "OF COURSE!! You've heard all about the %s:\n", item );
    send_to_char( buf, ch );
    sprintf( buf,
	"Object '%s' is type %s, extra flags %s.\n\r"
	"Weight is %d, value is %d, level is %d.\n\r",
	obj->name,
	item_name(obj->item_type),
	extra_bit_name(obj->extra_flags),
	obj->weight,
	obj->cost,
	obj->level );
    send_to_char( buf, ch );

    switch ( obj->item_type )
    {
    case ITEM_SCROLL:
    case ITEM_POTION:
    case ITEM_PILL: 
	sprintf( buf, "Level %d spells of:", obj->value[0] );
	send_to_char( buf, ch );

	if ( obj->value[1] >= 0 && obj->value[1] < MAX_SKILL )
	{
	    send_to_char( " '", ch );
	    send_to_char( skill_table[obj->value[1]].name, ch );
	    send_to_char( "'", ch );
	}

	if ( obj->value[2] >= 0 && obj->value[2] < MAX_SKILL )
	{
	    send_to_char( " '", ch );
	    send_to_char( skill_table[obj->value[2]].name, ch );
	    send_to_char( "'", ch );
	}

	if ( obj->value[3] >= 0 && obj->value[3] < MAX_SKILL )
	{
	    send_to_char( " '", ch );
	    send_to_char( skill_table[obj->value[3]].name, ch );
	    send_to_char( "'", ch );
	}

	send_to_char( ".\n\r", ch );
	break;

    case ITEM_WAND: 
    case ITEM_STAFF: 
	sprintf( buf, "Has %d(%d) charges of level %d",
	    obj->value[1], obj->value[2], obj->value[0] );
	send_to_char( buf, ch );
      
	if ( obj->value[3] >= 0 && obj->value[3] < MAX_SKILL )
	{
	    send_to_char( " '", ch );
	    send_to_char( skill_table[obj->value[3]].name, ch );
	    send_to_char( "'", ch );
	}

	send_to_char( ".\n\r", ch );
	break;
      
    case ITEM_WEAPON:
	send_to_char("Weapon type is ",ch);
	switch (obj->value[0])
	{
	case(WEAPON_EXOTIC)     : send_to_char("exotic.\n\r",ch);       break;
	case(WEAPON_BOW)	: send_to_char("bow.\n\r",ch);		break;
	case(WEAPON_SWORD)      : send_to_char("sword.\n\r",ch);        break;  
	case(WEAPON_DAGGER)     : send_to_char("dagger.\n\r",ch);       break;
	case(WEAPON_SPEAR)      : send_to_char("spear/staff.\n\r",ch);  break;
	case(WEAPON_MACE)       : send_to_char("mace/club.\n\r",ch);    break;
	case(WEAPON_AXE)        : send_to_char("axe.\n\r",ch);          break;
	case(WEAPON_FLAIL)      : send_to_char("flail.\n\r",ch);        break;
	case(WEAPON_WHIP)       : send_to_char("whip.\n\r",ch);         break;
	case(WEAPON_POLEARM)    : send_to_char("polearm.\n\r",ch);      break;
	default                 : send_to_char("unknown.\n\r",ch);      break;
	}
	if (obj->value[0] != WEAPON_BOW) {
	    if (obj->pIndexData->new_format)
		sprintf(buf,"Damage is %dd%d (average %d).\n\r",
		    obj->value[1],obj->value[2],
		    (1 + obj->value[2]) * obj->value[1] / 2);
	    else
		sprintf( buf, "Damage is %d to %d (average %d).\n\r",
		    obj->value[1], obj->value[2],
		    ( obj->value[1] + obj->value[2] ) / 2 );
	    send_to_char( buf, ch );
	}
	break;

    case ITEM_QUIVER:
	sprintf( buf, "There are %d arrows remaining in the quiver.\n\r", obj->value[0] );
	send_to_char( buf, ch );
	if (obj->pIndexData->new_format)
	    sprintf(buf,"Damage is %dd%d (average %d).\n\r",
		obj->value[1],obj->value[2],
		(1 + obj->value[2]) * obj->value[1] / 2);
	else
	    sprintf( buf, "Damage is %d to %d (average %d).\n\r",
		obj->value[1], obj->value[2],
		( obj->value[1] + obj->value[2] ) / 2 );
	send_to_char( buf, ch );
	break;

    case ITEM_ARROW:
	if (obj->pIndexData->new_format)
	    sprintf(buf,"Damage is %dd%d (average %d).\n\r",
		obj->value[1],obj->value[2],
		(1 + obj->value[2]) * obj->value[1] / 2);
	else
	    sprintf( buf, "Damage is %d to %d (average %d).\n\r",
		obj->value[1], obj->value[2],
		( obj->value[1] + obj->value[2] ) / 2 );
	send_to_char( buf, ch );
	break;

    case ITEM_ARMOR:
	sprintf( buf, 
	 "Armor class is %d pierce, %d bash, %d slash, and %d vs. magic.\n\r", 
	  obj->value[0], obj->value[1], obj->value[2], obj->value[3] );
	send_to_char( buf, ch );
	break;

    case ITEM_POISON:
	sprintf ( buf, "You recognise it as being %s poison.\n\r",
	      poison_type_name(obj->value[0]) );
	send_to_char( buf, ch );
	break;

    }

    if (!obj->enchanted)
    for ( paf = obj->pIndexData->affected; paf != NULL; paf = paf->next )
    {
	if ( paf->location != APPLY_NONE && paf->modifier != 0 )
	{
	    sprintf( buf, "Affects %s by %d.\n\r",
		    affect_loc_name( paf->location ), paf->modifier );
	    send_to_char( buf, ch );
	}
    }

    for ( paf = obj->affected; paf != NULL; paf = paf->next )
    {
	if ( paf->location != APPLY_NONE && paf->modifier != 0 )
	{
	    sprintf( buf, "Affects %s by %d.\n\r",
		    affect_loc_name( paf->location ), paf->modifier );
	    send_to_char( buf, ch );
	}
    }

    return;
}

void lore_success( CHAR_DATA *ch, char *item, OBJ_DATA *obj)
{
    char buf[MAX_STRING_LENGTH];
    int value;
    int level;
    int damage;
    int armor0;
    int armor1;
    int armor2;
    int armor3;
    AFFECT_DATA *paf1;
    AFFECT_DATA *paf2;

    value = obj->cost;

    sprintf( buf, "Ah yes..you remember something of this %s:\n\r", item);
    send_to_char( buf, ch );
    sprintf( buf, "It is most definitely some sort of %s.\n\r", 
	item_name(obj->item_type) );
    send_to_char( buf, ch );
    sprintf( buf, "You remember it having %s trade-in value.\n\r", 
	     value < 20 ? "worthless" : value < 50 ? "almost nil" :
	     value < 100  ?  "nominal" : value < 500 ? "almost decent" :
	     value < 1000  ?  "decent" : value < 5000 ? "pretty high" :
	     value < 10000  ?  "high" : value < 15000 ? "very high" :
	     value < 10000  ?  "OUTRAGEOUS" : value < 25000 ? "ASTRONOMICAL" :
	     "PRICELESS");
    send_to_char( buf, ch );

    switch ( obj->item_type )
    {
    case ITEM_SCROLL:
    case ITEM_POTION:
    case ITEM_PILL:
	level = obj->value[0];
	sprintf( buf, "It was enchanted with %s level spells of ",
		 level < 10 ? "lower" : level < 20 ? "medium" :
		 level < 30 ? "high" : level < 40 ? "VERY POWERFUL" :
		 "DIVINE" );
	send_to_char( buf, ch );

	if ( obj->value[1] >= 0 && obj->value[1] < MAX_SKILL )
	{
	    send_to_char( " '", ch );
	    send_to_char( skill_table[obj->value[1]].name, ch );
	    send_to_char( "'", ch );
	}

	if ( obj->value[2] >= 0 && obj->value[2] < MAX_SKILL )
	{
	    send_to_char( " '", ch );
	    send_to_char( skill_table[obj->value[2]].name, ch );
	    send_to_char( "'", ch );
	}

	if ( obj->value[3] >= 0 && obj->value[3] < MAX_SKILL )
	{
	    send_to_char( " '", ch );
	    send_to_char( skill_table[obj->value[3]].name, ch );
	    send_to_char( "'", ch );
	}

	send_to_char( ".\n\r", ch );
	break;
  
    case ITEM_WAND: 
    case ITEM_STAFF: 
	level = obj->value[0];
	sprintf( buf, "It's been enchanted with a %s level spell of",
		 level < 10 ? "lower" : level < 20 ? "medium" :
		 level < 30 ? "high" : level < 40 ? "VERY POWERFUL" :
		 "DIVINE" );
	send_to_char ( buf, ch );
 
	if ( obj->value[3] >= 0 && obj->value[3] < MAX_SKILL )
	{
	    send_to_char( " '", ch );
	    send_to_char( skill_table[obj->value[3]].name, ch );
	    send_to_char( "'", ch );
	}
	send_to_char( ".\n\r", ch );

	sprintf( buf, "You can't tell how many charges are left, but you remember it originally had %d.\n\r",
		 obj->value[2] );
	send_to_char( buf, ch );
	break;
	
  
    case ITEM_WEAPON:
	damage = obj->pIndexData->new_format ? 
			(1 + obj->value[2]) * obj->value[1] / 2 :
			(obj->value[2] + obj->value[1]) / 2;
	send_to_char("Its weapon type is ",ch);
	switch (obj->value[0])
	{
	case(WEAPON_EXOTIC)     : send_to_char("exotic.\n\r",ch);       break;
	case(WEAPON_BOW)	: send_to_char("bow.\n\r",ch);		break;
	case(WEAPON_SWORD)      : send_to_char("sword.\n\r",ch);        break;  
	case(WEAPON_DAGGER)     : send_to_char("dagger.\n\r",ch);       break;
	case(WEAPON_SPEAR)      : send_to_char("spear/staff.\n\r",ch);  break;
	case(WEAPON_MACE)       : send_to_char("mace/club.\n\r",ch);    break;
	case(WEAPON_AXE)        : send_to_char("axe.\n\r",ch);          break;
	case(WEAPON_FLAIL)      : send_to_char("flail.\n\r",ch);        break;
	case(WEAPON_WHIP)       : send_to_char("whip.\n\r",ch);         break;
	case(WEAPON_POLEARM)    : send_to_char("polearm.\n\r",ch);      break;
	default                 : send_to_char("unknown.\n\r",ch);      break;
	}
	if (obj->value[0] != WEAPON_BOW) {
	    sprintf ( buf, "Word has it the damage it does is %s.\n\r",
		  damage < 2 ? "minimal" : damage <  5 ? "painful" :
		  damage < 10 ? "awesome" : damage < 15 ? "BRUTAL" :
		  damage < 25 ? "DEADLY" : "LEGENDARY" );
	    send_to_char( buf, ch );
	}
	break;
    
    case ITEM_QUIVER:
	damage = obj->pIndexData->new_format ? 
			(1 + obj->value[2]) * obj->value[1] / 2 :
			(obj->value[2] + obj->value[1]) / 2;
	sprintf( buf, "There are %d arrows remaining in the quiver.\n\r", obj->value[0] );
	send_to_char( buf, ch );
	sprintf ( buf, "Word has it the damage it does is %s.\n\r",
		  damage < 2 ? "minimal" : damage <  5 ? "painful" :
		  damage < 10 ? "awesome" : damage < 15 ? "BRUTAL" :
		  damage < 25 ? "DEADLY" : "LEGENDARY" );
	send_to_char( buf, ch );
	break;

    case ITEM_ARROW:
	damage = obj->pIndexData->new_format ? 
			(1 + obj->value[2]) * obj->value[1] / 2 :
			(obj->value[2] + obj->value[1]) / 2;
	sprintf ( buf, "Word has it the damage it does is %s.\n\r",
		  damage < 2 ? "minimal" : damage <  5 ? "painful" :
		  damage < 10 ? "awesome" : damage < 15 ? "BRUTAL" :
		  damage < 25 ? "DEADLY" : "LEGENDARY" );
	send_to_char( buf, ch );
	break;


    case ITEM_ARMOR:
	armor0 = obj->value[0];
	armor1 = obj->value[1];
	armor2 = obj->value[2];
	armor3 = obj->value[3];
	sprintf( buf, 

	 "It's %s against pierce, %s against bash and %s against slash.\n\r",
	      armor0 < 1 ? "useless" : armor0 < 3 ? "OK" :
	      armor0 < 5 ? "strong" :  armor0 < 8 ? "GREAT" :
	      armor0 < 10 ? "OUTSTANDING" : "LEGENDARY",
	      armor1 < 1 ? "useless" : armor1 < 3 ? "OK" :
	      armor1 < 5 ? "strong" :  armor1 < 8 ? "GREAT" :
	      armor1 < 10 ? "OUTSTANDING" : "LEGENDARY",
	      armor2 < 1 ? "useless" : armor2 < 3 ? "OK" :
	      armor2 < 5 ? "strong" :  armor2 < 8 ? "GREAT" :
	      armor2 < 10 ? "OUTSTANDING" : "LEGENDARY" );
	send_to_char( buf, ch );
	sprintf ( buf, "You also remember it being %s against magic.\n\r",
	      armor3 < 0 ? "useless" : armor0 < 3 ? "OK" :
	      armor3 < 5 ? "strong" :  armor0 < 8 ? "GREAT" :
	      armor3 < 10 ? "OUTSTANDING" : "LEGENDARY" );
	send_to_char( buf, ch );
	break;
  
    case ITEM_POISON:
	sprintf ( buf, "You recognise it as being %s poison.\n\r",
	      poison_type_name(obj->value[0]) );
	send_to_char( buf, ch );
	break;

    }
 
    paf1 = obj->affected;
    paf2 = obj->pIndexData->affected; 
    if (paf1 == NULL && paf2 == NULL)
       return;
    
    for ( ; paf1 != NULL; paf1 = paf1->next )
    {
	if ( paf1->location != APPLY_NONE && paf1->modifier != 0 )
	{
	    sprintf( buf, "It also affects %s %s.\n\r",
		 affect_loc_name( paf1->location ),
		 paf1->modifier > 0 ? "positively" :
		 "negatively" );
	    send_to_char( buf, ch );
	}
    }

    for ( ; paf2 != NULL; paf2 = paf2->next )
    {
	if ( paf2->location != APPLY_NONE && paf2->modifier != 0 )
	{
	    sprintf( buf, "It also affects %s %s.\n\r",
		 affect_loc_name( paf2->location ),
		 paf2->modifier > 0 ? "in a positive way" :
		 "in a negative way" );
	    send_to_char( buf, ch );
	}
    }

    return;

}


void lore_detail(CHAR_DATA *ch, char *item, OBJ_DATA *obj)
{
    char buf[MAX_STRING_LENGTH];
    bool success;
    bool crit_success;
    int  chance;
    int  roll;

/* Check to see how successful the lore attempt was...   */    

    chance = get_skill( ch, gsn_lore );
    roll = number_percent();
 
    if (roll < chance)
    {
	success = TRUE;
	crit_success = number_percent() < ch->level + chance / 2 ? TRUE : FALSE;
    }
    else
    {
	success = FALSE;
	crit_success = FALSE;
    }

    if (!success)
    {
	sprintf( buf, 
	   "Hmmmm. You don't think you've ever heard about this %s.\r\n",
	    item );
	send_to_char( buf, ch );
	check_improve( ch, gsn_lore, FALSE, 4, TRUE );
	sprintf( buf, "$n looks intently at the %s but looks perplexed.\n\r", item );
	act ( buf, ch, NULL, NULL, TO_ROOM );
	return;
    }
    else
    {
	if (crit_success)
	{
	    lore_crit_success(ch, item, obj);
	    sprintf( buf, 
		"$n jumps up and down while staring at the %s.\n\r", item );
	    act ( buf, ch, NULL, NULL, TO_ROOM );
	}
	else    
	{
	    lore_success(ch, item, obj);
	    sprintf( buf, 
	       "$n seems to remember something about the %s.\n\r", item );
	    act ( buf, ch, NULL, NULL, TO_ROOM );
	}
	check_improve( ch, gsn_lore, TRUE, 8, TRUE );

    }
   
    return;
}

void do_lore( CHAR_DATA *ch, char *argument )
{
    char buf[MAX_STRING_LENGTH];
    char arg[MAX_INPUT_LENGTH];
    char *item;
    char *scrap;
    OBJ_DATA *obj;

    one_argument( argument, arg );

    if ( arg[0] == '\0' )
    {
	send_to_char( "In which item are you interested?\n\r", ch );
	return;
    }

    if ( ( obj = get_obj_here( ch, arg ) ) != NULL )
    {
	scrap = arg;
	item = one_argument(obj->short_descr, scrap);

	switch ( obj->item_type )
	{
	default:
	    lore_detail(ch, item, obj);
            WAIT_STATE( ch, skill_table[gsn_lore].beats );
	    break;
	case ITEM_CORPSE_NPC:
	    sprintf( buf, 
	      "No lore on this dead critter. Loot and sac it!\n\r" );
	    send_to_char( buf, ch );
	    act ( "$n looks intently at the dead body.\n\r", 
		  ch, NULL, NULL, TO_ROOM );
	    break;
	case ITEM_CORPSE_PC:
	    sprintf( buf, 
	      "It's common lore that it's good to help adventurers retrieve their corpse!\n\r" );
	    send_to_char( buf, ch );
	    break;
	    act( "$n looks closely at the corpse and seems enlightened.\n\r",
		 ch, NULL, NULL, TO_ROOM );
	}
    }
    else
    {
	sprintf( buf, "There is no %s here.\n\r", arg );
	send_to_char( buf, ch );
    }
    return;
}

