/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 ***************************************************************************/

/***************************************************************************
*   ROM 2.4 is copyright 1993-1996 Russ Taylor                             *
*   ROM has been brought to you by the ROM consortium                      *
*       Russ Taylor (rtaylor@pacinfo.com)                                  *
*       Gabrielle Taylor (gtaylor@pacinfo.com)                             *
*       Brian Moore (rom@rom.efn.org)                                      *
*   By using this code, you have agreed to follow the terms of the         *
*   ROM license, in the file Rom24/doc/rom.license                         *
***************************************************************************/

/***************************************************************************
*   THE LABYRINTH is copyright 1996-2002 Sherene Neil and William          *
*       Wallace                                                            *
*   THE LABYRINTH is brought to you by THE LABYRINTH Team:                 *
*   Sherene Wallace (sherene-dw@comcast.net)                               *
*   William Wallace (williamwallace@comcast.net)                           *
*                                                                          *
*   By using this code, you have agreed to follow the terms of the         *
*   ROM license, in the file Rom24/doc/rom.license                         *
***************************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#if defined(macintosh)
#include <types.h>
#elif defined(WIN32)
#include <time.h>
#else
#include <sys/types.h>
#include <sys/time.h>
#include <sys/resource.h>
#endif
#include "merc.h"
#include "olc.h"


DECLARE_DO_FUN( do_mpdump	);


void do_program( CHAR_DATA *ch, char *argument )
{
    char arg[MAX_INPUT_LENGTH];
    MPROG_CODE *pMProg;
    AREA_DATA *pArea;
    int vnum;
    
    if ( ch->in_room == NULL )
    {
	send_to_char( "You need to be in a room before you try doing that.\n\r", ch );
	return;
    }
    
    pArea = ch->in_room->area;

    if ( !is_creator(ch, pArea) )
    {
	send_to_char( "You are not a creator in this area.\n\r", ch );
	return;
    }
    
    if ( argument[0] == '\0' )
    {
	send_to_char( "Syntax: prog <vnum>\n\r"
	              "        prog <vnum> NULL\n\r"
	              "        prog <vnum> + <program line>\n\r"
	              "        prog <vnum> - [line number]\n\r"
	              "        prog <vnum> i <line number> <program line>\n\r"
	              "        prog <vnum> c <line number> <program line>\n\r",
	              ch );
	return;
    }

    argument = one_argument( argument, arg );
    vnum = atoi( arg );

    if ( (pMProg = get_mprog_index(atoi(arg))) == NULL )
    {
	send_to_char( "No program with that vnum found.\n\r", ch );
	return;
    }
    
    if ( vnum < pArea->min_vnum || vnum > pArea->max_vnum )
    {
	send_to_char( "That vnum does not lie within this area.\n\r", ch );
	return;
    }

    if ( argument[0] == '\0' )
    {
	do_mpdump( ch, arg );
	return;
    }

    if ( edit_desc(ch, &pMProg->code, argument) )
	SET_BIT( pArea->flags, AREA_DIRTY );
}
